 package cs.cinvestav;
 
 import java.util.ArrayList;
 import java.util.HashSet;
 import java.util.Iterator;
 
 public class CFG
{
   public static double VALOR_CONEXION = 0.0D;
   public static double VALOR_OJO = 4.0D;
   public static double VALOR_RED = 6.0D;
   public static double VALOR_ESCALERA = 8.0D;
   public static double VALOR_INVASION = 4.0D;
   public static double VALOR_REDUCCION = 2.0D;
   public static double VALOR_LIBERTAD_SIMPLE = 1.0D;
   private ArrayList<NodoCFG> nodos = new ArrayList();
   
   public ArrayList<NodoCFG> getNodos()
   {
     return this.nodos;
   }

   public void setNodos(ArrayList<NodoCFG> nodos)
   {
     this.nodos = nodos;
   }

   public CFG(ArrayList<NodoCFG> nodos)
   {
     this.nodos = nodos;
   }
   
   public static CFG generarCFG(ArrayList<ArrayList<PiedraSimple>> piedrasCompuestas, ArrayList<LibertadEspecial> libertadesEspeciales)
   {
      NodoCFG nodo1;
     ArrayList<LibertadEspecial> recorridas;
     //Iterator i$;
     //Punto punto1;
     //LibertadEspecial libertad;
     double peso;
     ArrayList<NodoCFG> nodos = new ArrayList();
    int id = 0;
     for (ArrayList<PiedraSimple> piedraCompuesta : piedrasCompuestas)
     {
       int tamanio = piedraCompuesta.size();
       
       int color = NodoCFG.COLOR_BLANCO;
       if (((PiedraSimple)piedraCompuesta.get(0)).getColor() == ProcesadorTablero.ETIQUETA_NEGRO) {
         color = NodoCFG.COLOR_NEGRO;
       }
       int ojos = 0;
       
 
       ArrayList<Punto> puntos = new ArrayList();
       for (PiedraSimple piedra : piedraCompuesta) {
         puntos.add(new Punto(piedra.getPosicionX(), piedra.getPosicionY()));
       }
       HashSet<Punto> libertades = new HashSet();
       PiedraSimple piedra;
       for (Iterator i$ = piedraCompuesta.iterator(); i$.hasNext();)
       {
         piedra = (PiedraSimple)i$.next();
         for (LibertadEspecial libertad : libertadesEspeciales) {
           if (((piedra.getPosicionX() + 1 == libertad.getPosicionX()) && (piedra.getPosicionY() == libertad.getPosicionY())) || ((piedra.getPosicionX() - 1 == libertad.getPosicionX()) && (piedra.getPosicionY() == libertad.getPosicionY())) || ((piedra.getPosicionX() == libertad.getPosicionX()) && (piedra.getPosicionY() + 1 == libertad.getPosicionY())) || ((piedra.getPosicionX() == libertad.getPosicionX()) && (piedra.getPosicionY() - 1 == libertad.getPosicionY()))) {
             libertades.add(new Punto(libertad.getPosicionX(), libertad.getPosicionY()));
           }
         }
       }
       
       int noLibertades = libertades.size();
       
       nodos.add(new NodoCFG(noLibertades, tamanio, ojos, color, puntos, id));
       
       id++;
     }
     for (Iterator i$ = nodos.iterator(); i$.hasNext();)
     {
       nodo1 = (NodoCFG)i$.next();
       for (NodoCFG nodo2 : nodos) {
         if (nodo1.getId() != nodo2.getId())
         {
           boolean estanConectados = false;
           for (Punto punto1 : nodo1.getUbicacionPiedras())
           {
             for (Punto punto2 : nodo2.getUbicacionPiedras()) {
               if (((punto1.getX() + 1 == punto2.getX()) && (punto1.getY() == punto2.getY())) || ((punto1.getX() - 1 == punto2.getX()) && (punto1.getY() == punto2.getY())) || ((punto1.getX() == punto2.getX()) && (punto1.getY() + 1 == punto2.getY())) || ((punto1.getX() == punto2.getX()) && (punto1.getY() - 1 == punto2.getY())))
               {
                 estanConectados = true;
                 break;
               }
             }
             if (estanConectados) {
               break;
             }
           }
           if (estanConectados) {
             if ((nodo2.getLibertades() != 2) && (nodo2.getLibertades() != 1))
             {
               nodo1.agregarAristas(new AristaCFG[] { new AristaCFG(nodo2, VALOR_CONEXION) });
             }
             else if (nodo2.getLibertades() == 2)
             {
               nodo1.agregarAristas(new AristaCFG[] { new AristaCFG(nodo2, -VALOR_RED) });
               
               nodo2.agregarAristas(new AristaCFG[] { new AristaCFG(nodo1, VALOR_RED) });
             }
             else
             {
               nodo1.agregarAristas(new AristaCFG[] { new AristaCFG(nodo2, -VALOR_ESCALERA) });
               
               nodo2.agregarAristas(new AristaCFG[] { new AristaCFG(nodo1, VALOR_ESCALERA) });
             }
           }
         }
       }
     }
     //NodoCFG nodo1;
     for (Iterator i$ = nodos.iterator(); i$.hasNext();)
     {
       nodo1 = (NodoCFG)i$.next();
       recorridas = new ArrayList();
       for (i$ = nodo1.getUbicacionPiedras().iterator(); i$.hasNext();)
       {
         Punto punto1 = (Punto)i$.next();
         for (i$ = libertadesEspeciales.iterator(); i$.hasNext();)
         {
           LibertadEspecial libertad = (LibertadEspecial)i$.next();
           if (((punto1.getX() + 1 == libertad.getPosicionX()) && (punto1.getY() == libertad.getPosicionY())) || ((punto1.getX() - 1 == libertad.getPosicionX()) && (punto1.getY() == libertad.getPosicionY())) || ((punto1.getX() == libertad.getPosicionX()) && (punto1.getY() + 1 == libertad.getPosicionY())) || ((punto1.getX() == libertad.getPosicionX()) && (punto1.getY() - 1 == libertad.getPosicionY()))) {
             if (!recorridas.contains(libertad))
             {
               recorridas.add(libertad);
               
 
 
               int color = libertad.getColor();
               peso = VALOR_CONEXION;
               if (color == ProcesadorTablero.ETIQUETA_ESPACIO) {
                 peso = VALOR_LIBERTAD_SIMPLE;
               } else if (color == ProcesadorTablero.ETIQUETA_OJO) {
                 peso = VALOR_OJO;
               } else if ((color == ProcesadorTablero.ETIQUETA_ESCALERA_BLANCA) || (color == ProcesadorTablero.ETIQUETA_ESCALERA_NEGRA)) {
                 peso = VALOR_LIBERTAD_SIMPLE;
               } else if ((color == ProcesadorTablero.ETIQUETA_RED_BLANCA) || (color == ProcesadorTablero.ETIQUETA_RED_NEGRA)) {
                 peso = VALOR_LIBERTAD_SIMPLE;
               } else if ((color == ProcesadorTablero.ETIQUETA_INVASION_BLANCA) || (color == ProcesadorTablero.ETIQUETA_INVASION_NEGRA)) {
                 peso = VALOR_INVASION;
               } else if ((color == ProcesadorTablero.ETIQUETA_REDUCCION_BLANCA) || (color == ProcesadorTablero.ETIQUETA_REDUCCION_NEGRA)) {
                 peso = VALOR_REDUCCION;
               }
               for (NodoCFG nodo2 : nodos)
               {
                 boolean estanRelacionados = false;
                 if (nodo1.getId() != nodo2.getId()) {
                   for (Punto punto2 : nodo2.getUbicacionPiedras()) {
                     if (((punto2.getX() + 1 == libertad.getPosicionX()) && (punto2.getY() == libertad.getPosicionY())) || ((punto2.getX() - 1 == libertad.getPosicionX()) && (punto2.getY() == libertad.getPosicionY())) || ((punto2.getX() == libertad.getPosicionX()) && (punto2.getY() + 1 == libertad.getPosicionY())) || ((punto2.getX() == libertad.getPosicionX()) && (punto2.getY() - 1 == libertad.getPosicionY())))
                     {
                       estanRelacionados = true;
                       break;
                     }
                   }
                 }
                 if (estanRelacionados) {
                   nodo1.agregarAristas(new AristaCFG[] { new AristaCFG(nodo2, peso) });
                 }
               }
             }
           }
         }
       }
     }
     
     
     CFG cfg = new CFG(nodos);
     return cfg;
   }
 }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.CFG

 * JD-Core Version:    0.7.0.1

 */