 package cs.cinvestav;
 
 import java.awt.Color;
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
 import java.io.File;
 import java.io.IOException;
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.Comparator;
 import java.util.HashMap;
 import java.util.LinkedHashMap;
 import java.util.LinkedList;
 import java.util.List;
 import java.util.Map;
 import java.util.Random;
 import java.util.logging.Level;
 import java.util.logging.Logger;
 import javax.swing.BorderFactory;
 import javax.swing.ImageIcon;
 import javax.swing.JButton;
 import javax.swing.JFileChooser;
 import javax.swing.JFrame;
 import javax.swing.JLabel;
 import javax.swing.JPanel;
 import javax.swing.JTabbedPane;
 import javax.swing.JTextField;
 import net.miginfocom.swing.MigLayout;
 import org.jfree.chart.ChartPanel;
 
 public class CFGGUI extends JFrame{
   private static final long serialVersionUID = -900723105572845592L;
   private int tamanioTablero;
   final JFileChooser fc = new JFileChooser();
   private JButton cargarTableroButton;
   private JButton generarTableroButton;
   private JButton procesarTableroButton;
   private JButton reiniciarTableroButton;
   private JButton cargarSiguienteButton;
   private JButton cargarTodasButton;
   private JButton mejoresJugadasButton;
   private JButton reiniciarPartidaButton;
   private JPanel contentPanel = (JPanel)getContentPane();
   private JPanel goPanel;
   private Tablero tableroPanel;
   private JPanel menuTableroPanel;
   private JPanel menuPartidaPanel;
   private JPanel infoPartidaPanel;
   private JPanel grafoPanel;
   private JPanel wPanel;
   private JPanel graficaPanel;
   private JPanel grafica2Panel;
   private JPanel jugadasPanel;
   private Tablero siguienteTableroPanel;
   private CFGPanel cfgPanel;
   private IsingPanel isingPanel;
   private VectorPanel vectorPanel;
   private VectorLibPanel vectorLibPanel;
   private JPanel energiaPanel;
   private JTextField totalBlancasField;
   private JTextField totalNegrasField;
   private JTabbedPane tabPanel;
   public static int PROPORCION_BLANCAS = 20;
   public static int PROPORCION_NEGRAS = 20;
   public static int PROPORCION_VACIOS = 60;
   private SGGoJuego juego = null;
   private int indexJugada = 0;
   private ArrayList<Integer> historico = new ArrayList();
   private ArrayList<Double> historicoBlancas = new ArrayList();
   private ArrayList<Double> historicoNegras = new ArrayList();
   private boolean visible = true;

   public CFGGUI(int tamanioTablero, boolean visible){

     this.tamanioTablero = tamanioTablero;
     this.visible = visible;
 
     this.tabPanel = new JTabbedPane();

     this.goPanel = new JPanel();
     this.goPanel.setLayout(new MigLayout());
     
     this.tableroPanel = new Tablero(Integer.valueOf(tamanioTablero), Integer.valueOf(tamanioTablero), Tablero.JUEGO_GO);
     
     this.tableroPanel.setBorder(BorderFactory.createTitledBorder("Tablero de pruebas"));
     
     this.menuTableroPanel = new JPanel();
     this.menuTableroPanel.setLayout(new MigLayout());
     
     this.cargarTableroButton = new JButton("Cargar partida", new ImageIcon("images/open16.gif"));
     
     this.cargarTableroButton.addActionListener(new ClickOnCargarTableroButton());
     
     this.cargarSiguienteButton = new JButton("Cargar siguiente jugada", new ImageIcon("images/forward16.gif"));
     
     this.cargarSiguienteButton.addActionListener(new ClickOnCargarSiguienteButton());
     
     this.cargarTodasButton = new JButton("Cargar todas las jugadas", new ImageIcon("images/fastforward16.gif"));     
 
     this.generarTableroButton = new JButton("Generar tablero");
     this.generarTableroButton.addActionListener(new ClickOnGenerarTableroButton());
 
     this.procesarTableroButton = new JButton("Procesar tablero");
     this.procesarTableroButton.addActionListener(new ClickOnProcesarTableroButton());
 
     this.reiniciarTableroButton = new JButton("Reiniciar tablero");
     this.reiniciarTableroButton.addActionListener(new ClickOnReiniciarTableroButton());
      
     this.reiniciarPartidaButton = new JButton("Reiniciar partida", new ImageIcon("images/redo16.gif"));
     
     this.reiniciarPartidaButton.addActionListener(new ClickOnReiniciarPartidaButton());
     
 
     this.mejoresJugadasButton = new JButton("Obtener mejores jugadas");
     this.mejoresJugadasButton.addActionListener(new ClickOnMejoresJugadasButton());
     
 
     this.menuTableroPanel = new JPanel();
     this.menuTableroPanel.setLayout(new MigLayout("fillx"));
     this.menuTableroPanel.setBorder(BorderFactory.createTitledBorder("Menú tablero"));
     
     this.menuTableroPanel.add(this.generarTableroButton, "wrap, grow");
     this.menuTableroPanel.add(this.reiniciarTableroButton, "wrap, grow");
     this.menuTableroPanel.add(this.procesarTableroButton, "wrap, grow");
     this.menuTableroPanel.add(this.mejoresJugadasButton, "wrap, grow");
     
     this.menuPartidaPanel = new JPanel();
     this.menuPartidaPanel.setLayout(new MigLayout("fillx"));
     this.menuPartidaPanel.setBorder(BorderFactory.createTitledBorder("Menú partida"));
     
     this.menuPartidaPanel.add(this.cargarTableroButton, "wrap, grow");
     this.menuPartidaPanel.add(this.cargarSiguienteButton, "wrap, grow");
     
     this.menuPartidaPanel.add(this.reiniciarPartidaButton, "wrap, grow");
     
     this.infoPartidaPanel = new JPanel();
     this.infoPartidaPanel.setLayout(new MigLayout());
     this.infoPartidaPanel.setBorder(BorderFactory.createTitledBorder("Información de la partida"));
     
     this.goPanel.add(this.tableroPanel, "cell 0 0, span 0 3, aligny top");
     this.goPanel.add(this.menuTableroPanel, "cell 1 0, aligny top, grow");
     this.goPanel.add(this.menuPartidaPanel, "cell 1 1, aligny top, grow");
     this.goPanel.add(this.infoPartidaPanel, "cell 1 2, aligny top, grow");
     
 
     this.grafoPanel = new JPanel();
     this.grafoPanel.setLayout(new MigLayout("fillx"));
     
     this.cfgPanel = new CFGPanel(Integer.valueOf(tamanioTablero), Integer.valueOf(tamanioTablero));
     this.cfgPanel.setBorder(BorderFactory.createTitledBorder("Grafo de destino común"));
     
     this.grafoPanel.add(this.cfgPanel, "wrap, alignx center");
     
 
     this.wPanel = new JPanel();
     this.wPanel.setLayout(new MigLayout("fillx"));
     
     this.isingPanel = new IsingPanel(Integer.valueOf(tamanioTablero), Integer.valueOf(tamanioTablero));
     this.isingPanel.setBorder(BorderFactory.createTitledBorder("Matriz de pesos"));
     this.vectorPanel = new VectorPanel(Integer.valueOf(tamanioTablero));
     this.vectorPanel.setBorder(BorderFactory.createTitledBorder("Vector X"));
     this.vectorLibPanel = new VectorLibPanel(Integer.valueOf(tamanioTablero));
     this.vectorLibPanel.setBorder(BorderFactory.createTitledBorder("Campo"));
     
     this.totalBlancasField = new JTextField("0.0");
     this.totalNegrasField = new JTextField("0.0");
     
     this.energiaPanel = new JPanel(new MigLayout("fillx"));
     this.energiaPanel.setBorder(BorderFactory.createTitledBorder("Energía"));
     this.energiaPanel.add(new JLabel("Energía total de piedras blancas"), "wrap");
     this.energiaPanel.add(this.totalBlancasField, "wrap, grow");
     this.energiaPanel.add(new JLabel("Energía total de piedras negras"), "wrap");
     this.energiaPanel.add(this.totalNegrasField, "wrap, grow");
     
     this.wPanel.add(this.vectorPanel, "cell 0 0, aligny top");
     this.wPanel.add(this.isingPanel, "cell 1 0, aligny top");
     this.wPanel.add(this.vectorLibPanel, "cell 2 0, aligny top");
     this.wPanel.add(this.energiaPanel, "cell 1 1, aligny top, grow");
     
 
     this.graficaPanel = new JPanel();
     this.graficaPanel.setLayout(new MigLayout("fillx"));
     
     this.graficaPanel.add(GraficaPanel.generarGrafica(tamanioTablero, tamanioTablero, this.historico), "wrap, alignx center");
     
 
     this.grafica2Panel = new JPanel();
     this.grafica2Panel.setLayout(new MigLayout("fillx"));
     
     this.grafica2Panel.add(GraficaEnergiaPanel.generarGrafica(tamanioTablero, tamanioTablero, this.historicoBlancas, this.historicoNegras), "wrap, alignx center");
     
 
     this.jugadasPanel = new JPanel();
     this.jugadasPanel.setLayout(new MigLayout("fillx"));
     
     this.siguienteTableroPanel = new Tablero(Integer.valueOf(tamanioTablero), Integer.valueOf(tamanioTablero), Tablero.JUEGO_GO);
     
     this.siguienteTableroPanel.setBorder(BorderFactory.createTitledBorder("Mejores siguientes jugadas"));
     this.siguienteTableroPanel.setEnabled(false);
     
     this.jugadasPanel.add(this.siguienteTableroPanel, "wrap, alignx center");
     
 
     this.tabPanel.addTab("Tablero", null, this.goPanel, "Tablero de pruebas");
     
     this.tabPanel.setMnemonicAt(0, 49);
     
     this.tabPanel.addTab("CFG", null, this.grafoPanel, "Grafo de destino común");
     
     this.tabPanel.setMnemonicAt(1, 50);
     
     this.tabPanel.addTab("Ising", null, this.wPanel, "Modelo de ising");
     
     this.tabPanel.setMnemonicAt(2, 51);
     
     this.tabPanel.addTab("Jugadas", null, this.jugadasPanel, "Mejores próximas jugadas");
     
     this.tabPanel.setMnemonicAt(3, 52);
     
     this.tabPanel.addTab("Gráfica", null, this.graficaPanel, "Gráfica del desarrollo de juego");
     
     this.tabPanel.setMnemonicAt(4, 53);
     
     this.tabPanel.addTab("Gráfica 2", null, this.grafica2Panel, "Gráfica de energías del juego");
     
     this.tabPanel.setMnemonicAt(5, 54);
     
     setContentPane(this.tabPanel);
     
     pack();
     setTitle("CFG Extendido");
     setVisible(visible);
     setResizable(false);
     setDefaultCloseOperation(3);
     habilitarMenuTablero();
   }
   
   public CFGGUI(int tamanioTablero){
       this(tamanioTablero, true);
   }
   
   public int getTamanioTablero()
   {
     return this.tamanioTablero;
   }
   
   public void setTamanioTablero(int tamanioTablero)
   {
     this.tamanioTablero = tamanioTablero;
   }
   
   private class ClickOnCargarSiguienteButton implements ActionListener
   {
     private ClickOnCargarSiguienteButton() {}
     
     public void actionPerformed(ActionEvent e)
     {
       CFGGUI.this.setSiguienteJugada();
     }
   }
   
   public void cargarPartida(){
       int returnVal = this.fc.showOpenDialog(this);
       if (returnVal == 0)
       {
         File tableroGoFile = this.fc.getSelectedFile();
         this.cargarPartida(tableroGoFile);
       }
   }
   
   public void cargarPartida(File gamefile){
    this.juego = SGGoParser.getJuegoGo(gamefile.getPath());
    if ((this.juego == null) || (this.juego.getJugadas().size() == 0))
    {
      this.infoPartidaPanel.removeAll();
      JLabel errorFormato = new JLabel("<html>Formato de juego incorrecto <br>(debe estar en SGF)<html>");
      errorFormato.setForeground(Color.RED);
      this.infoPartidaPanel.add(errorFormato, "wrap");
      return;
    }
    reiniciarTodo();
    habilitarMenuPartida();

    this.infoPartidaPanel.removeAll();
    this.infoPartidaPanel.add(new JLabel("<html><b>Jugador blanco:</b></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><i>" + this.juego.getJugadorBlanco() + "</i></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><b>Jugador negro:</b></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><i>" + this.juego.getJugadorNegro() + "</i></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><b>Evento:</b></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><i>" + this.juego.getNombreEvento() + "</i></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><b>Lugar:</b></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><i>" + this.juego.getLugar() + "</i></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><b>Fecha:</b></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><i>" + this.juego.getFecha() + "</i></html>"), "wrap");
    this.infoPartidaPanel.add(new JLabel("<html><b>Ganador:</b></html>"), "wrap");

    String ganador = "Empate";
    if (this.juego.getGanador() == SGGoParser.NEGRO) {
      ganador = "Negro";
    } else if (this.juego.getGanador() == SGGoParser.BLANCO) {
      ganador = "Blanco";
    }
    this.infoPartidaPanel.add(new JLabel("<html><i>" + ganador + "</i></html>"), "wrap");
   }
   
   public void correrPartida(){
       if(this.juego!=null){
            boolean next = this.setSiguienteJugada();
            while(next) next = this.setSiguienteJugada();
            //try {
            //    this.guardarGraficas();
            //} catch (IOException ex) {
            //   Logger.getLogger(CFGGUI.class.getName()).log(Level.SEVERE, null, ex);
            //}
       }
   }
   
   
   private class ClickOnCargarTableroButton implements ActionListener{
     private ClickOnCargarTableroButton() {}
     
     public void actionPerformed(ActionEvent e)
     {
         CFGGUI.this.cargarPartida();
         CFGGUI.this.setSiguienteJugada();
/*       int returnVal = CFGGUI.this.fc.showOpenDialog(CFGGUI.this);
       if (returnVal == 0)
       {
         File tableroGoFile = CFGGUI.this.fc.getSelectedFile();
         CFGGUI.this.juego = SGGoParser.getJuegoGo(tableroGoFile.getPath());
         if ((CFGGUI.this.juego == null) || (CFGGUI.this.juego.getJugadas().size() == 0))
         {
           CFGGUI.this.infoPartidaPanel.removeAll();
           JLabel errorFormato = new JLabel("<html>Formato de juego incorrecto <br>(debe estar en SGF)<html>");
           errorFormato.setForeground(Color.RED);
           CFGGUI.this.infoPartidaPanel.add(errorFormato, "wrap");
           return;
         }
         CFGGUI.this.reiniciarTodo();
         CFGGUI.this.habilitarMenuPartida();
         
         CFGGUI.this.infoPartidaPanel.removeAll();
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><b>Jugador blanco:</b></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><i>" + CFGGUI.this.juego.getJugadorBlanco() + "</i></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><b>Jugador negro:</b></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><i>" + CFGGUI.this.juego.getJugadorNegro() + "</i></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><b>Evento:</b></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><i>" + CFGGUI.this.juego.getNombreEvento() + "</i></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><b>Lugar:</b></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><i>" + CFGGUI.this.juego.getLugar() + "</i></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><b>Fecha:</b></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><i>" + CFGGUI.this.juego.getFecha() + "</i></html>"), "wrap");
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><b>Ganador:</b></html>"), "wrap");
         
         String ganador = "Empate";
         if (CFGGUI.this.juego.getGanador() == SGGoParser.NEGRO) {
           ganador = "Negro";
         } else if (CFGGUI.this.juego.getGanador() == SGGoParser.BLANCO) {
           ganador = "Blanco";
         }
         CFGGUI.this.infoPartidaPanel.add(new JLabel("<html><i>" + ganador + "</i></html>"), "wrap");

         boolean next = CFGGUI.this.setSiguienteJugada();
         while(next) next = CFGGUI.this.setSiguienteJugada();
           try {
               CFGGUI.this.guardarGraficas();
           } catch (IOException ex) {
               Logger.getLogger(CFGGUI.class.getName()).log(Level.SEVERE, null, ex);
           }
       }*/
     }
   }
   
   private class ClickOnGenerarTableroButton
     implements ActionListener
   {
     private ClickOnGenerarTableroButton() {}
     
     public void actionPerformed(ActionEvent e)
     {
       CFGGUI.this.habilitarMenuTablero();
       for (int x = 0; x < CFGGUI.this.tableroPanel.getAncho().intValue(); x++) {
         for (int y = 0; y < CFGGUI.this.tableroPanel.getAlto().intValue(); y++)
         {
           int numeroAleatorio = new Random().nextInt(CFGGUI.PROPORCION_BLANCAS + CFGGUI.PROPORCION_NEGRAS + CFGGUI.PROPORCION_VACIOS);
           if ((numeroAleatorio >= 0) && (numeroAleatorio < CFGGUI.PROPORCION_BLANCAS)) {
             CFGGUI.this.tableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_BLANCA.intValue());
           } else if ((numeroAleatorio >= CFGGUI.PROPORCION_BLANCAS) && (numeroAleatorio < CFGGUI.PROPORCION_BLANCAS + CFGGUI.PROPORCION_NEGRAS)) {
             CFGGUI.this.tableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_NEGRA.intValue());
           } else {
             CFGGUI.this.tableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_VACIA.intValue());
           }
           CFGGUI.this.siguienteTableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_VACIA.intValue());
         }
       }
       CFGGUI.this.tableroPanel.repaint();
     }
   }
   
   private class ClickOnReiniciarTableroButton
     implements ActionListener
   {
     private ClickOnReiniciarTableroButton() {}
     
     public void actionPerformed(ActionEvent e)
     {
       CFGGUI.this.habilitarMenuTablero();
       for (int x = 0; x < CFGGUI.this.tableroPanel.getAncho().intValue(); x++) {
         for (int y = 0; y < CFGGUI.this.tableroPanel.getAlto().intValue(); y++)
         {
           CFGGUI.this.tableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_VACIA.intValue());
           
           CFGGUI.this.siguienteTableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_VACIA.intValue());
         }
       }
       CFGGUI.this.tableroPanel.repaint();
       CFGGUI.this.siguienteTableroPanel.repaint();
     }
   }
   
   private class ClickOnProcesarTableroButton
     implements ActionListener
   {
     private ClickOnProcesarTableroButton() {}
     
     public void actionPerformed(ActionEvent e)
     {
       int[][] tablero = new int[CFGGUI.this.tamanioTablero][CFGGUI.this.tamanioTablero];
       for (int x = 0; x < CFGGUI.this.tableroPanel.getAncho().intValue(); x++) {
         for (int y = 0; y < CFGGUI.this.tableroPanel.getAlto().intValue(); y++)
         {
           int jugador = (int)CFGGUI.this.tableroPanel.getCasilla(y, x).getJugador();
           if (jugador == JugadorBD.GO_FICHA_BLANCA.intValue()) {
             tablero[x][y] = ProcesadorTablero.ETIQUETA_BLANCO;
           } else if (jugador == JugadorBD.GO_FICHA_NEGRA.intValue()) {
             tablero[x][y] = ProcesadorTablero.ETIQUETA_NEGRO;
           } else if (jugador == JugadorBD.GO_FICHA_VACIA.intValue()) {
             tablero[x][y] = ProcesadorTablero.ETIQUETA_ESPACIO;
           }
         }
       }
       ProcesadorTablero procesadorTablero = new ProcesadorTablero(tablero, CFGGUI.this.tamanioTablero);
       
       procesadorTablero.leerGrafo();
       
       CFGGUI.this.cfgPanel.setPiedrasCompuestas(procesadorTablero.getPiedrasCompuestas());
       
       CFGGUI.this.cfgPanel.setLibertadesEspeciales(procesadorTablero.getLibertadesEspeciales());
       
       CFGGUI.this.cfgPanel.repaint();
       
       System.out.println("Piedras " + procesadorTablero.getPiedrasCompuestas().size());
       
 
 
       CFG cfg = CFG.generarCFG(procesadorTablero.getPiedrasCompuestas(), procesadorTablero.getLibertadesEspeciales());
       
 
       int tamanio = cfg.getNodos().size();
       double valor = 0.0D;
       CFGGUI.this.isingPanel.actualizar(cfg);
       CFGGUI.this.vectorPanel.actualizar(cfg);
       CFGGUI.this.vectorLibPanel.actualizar(cfg);
       CFGGUI.this.isingPanel.setVisible(true);
       CFGGUI.this.vectorPanel.setVisible(true);
       CFGGUI.this.vectorLibPanel.setVisible(true);
       
       System.out.println("------------------------------------");
       
 
       float valor_negras = 0.0F;
       float valor_blancas = 0.0F;
       for (int x = 0; x < tamanio; x++)
       {
         valor = 0.0D;
         NodoCFG nodo = (NodoCFG)cfg.getNodos().get(x);
         for (int y = 0; y < tamanio; y++) {
           valor += -0.5D * (CFGGUI.this.vectorPanel.getValor(x) * CFGGUI.this.vectorPanel.getValor(y) * CFGGUI.this.isingPanel.getValor(x, y));
         }
         valor -= CFGGUI.this.vectorLibPanel.getValor(x) * Math.abs(CFGGUI.this.vectorPanel.getValor(x));
         System.out.println("Energía nodo " + (x + 1) + " " + valor);
         if (nodo.getColor() == -1) {
           valor_negras = (float)(valor_negras + valor);
         } else {
           valor_blancas = (float)(valor_blancas + valor);
         }
       }
       CFGGUI.this.totalBlancasField.setText(String.valueOf(valor_blancas));
       CFGGUI.this.totalNegrasField.setText(String.valueOf(valor_negras));
       if (valor_negras < valor_blancas)
       {
         CFGGUI.this.totalNegrasField.setBackground(Color.GREEN);
         CFGGUI.this.totalNegrasField.setForeground(Color.BLACK);
         CFGGUI.this.totalBlancasField.setBackground(Color.RED);
         CFGGUI.this.totalBlancasField.setForeground(Color.WHITE);
       }
       else if (valor_negras > valor_blancas)
       {
         CFGGUI.this.totalNegrasField.setBackground(Color.RED);
         CFGGUI.this.totalNegrasField.setForeground(Color.WHITE);
         CFGGUI.this.totalBlancasField.setBackground(Color.GREEN);
         CFGGUI.this.totalBlancasField.setForeground(Color.BLACK);
       }
       else if (valor_negras == valor_blancas)
       {
         CFGGUI.this.totalNegrasField.setBackground(Color.YELLOW);
         CFGGUI.this.totalNegrasField.setForeground(Color.BLACK);
         CFGGUI.this.totalBlancasField.setBackground(Color.YELLOW);
         CFGGUI.this.totalBlancasField.setForeground(Color.BLACK);
       }
       CFGGUI.this.pack();
     }
   }
   
   private class ClickOnReiniciarPartidaButton
     implements ActionListener
   {
     private ClickOnReiniciarPartidaButton() {}
     
     public void actionPerformed(ActionEvent e)
     {
       CFGGUI.this.reiniciarTodo();
       CFGGUI.this.habilitarMenuPartida();
       CFGGUI.this.setSiguienteJugada();
     }
   }
   
   private class ClickOnMejoresJugadasButton implements ActionListener
   {
     private ClickOnMejoresJugadasButton() {}
     
     public void actionPerformed(ActionEvent e)
     {
       for (int x = 0; x < CFGGUI.this.tableroPanel.getAncho().intValue(); x++) {
         for (int y = 0; y < CFGGUI.this.tableroPanel.getAlto().intValue(); y++) {
           CFGGUI.this.siguienteTableroPanel.getCasilla(x, y).setJugador(CFGGUI.this.tableroPanel.getCasilla(x, y).getJugador());
         }
       }
       Map<Punto, Double> mapBlancasConBlancas = new HashMap();
       
       Map<Punto, Double> mapNegrasConBlancas = new HashMap();
       
       Map<Punto, Double> mapNegrasConNegras = new HashMap();
       
       Map<Punto, Double> mapBlancasConNegras = new HashMap();
       
       double valorActualNegras = CFGGUI.this.procesarMejoresJugadas(JugadorBD.GO_FICHA_NEGRA.intValue());
       double valorActualBlancas = CFGGUI.this.procesarMejoresJugadas(JugadorBD.GO_FICHA_BLANCA.intValue());
       for (int x = 0; x < CFGGUI.this.siguienteTableroPanel.getAncho().intValue(); x++) {
         for (int y = 0; y < CFGGUI.this.siguienteTableroPanel.getAlto().intValue(); y++) {
           if (CFGGUI.this.siguienteTableroPanel.getCasilla(x, y).getJugador() == JugadorBD.GO_FICHA_VACIA.intValue())
           {
             CFGGUI.this.siguienteTableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_BLANCA.intValue());
             double valorBlancasConBlancas = CFGGUI.this.procesarMejoresJugadas(JugadorBD.GO_FICHA_BLANCA.intValue());
             mapBlancasConBlancas.put(new Punto(x, y), Double.valueOf(valorBlancasConBlancas));
             double valorNegrasConBlancas = CFGGUI.this.procesarMejoresJugadas(JugadorBD.GO_FICHA_NEGRA.intValue());
             mapNegrasConBlancas.put(new Punto(x, y), Double.valueOf(valorNegrasConBlancas));
             
             CFGGUI.this.siguienteTableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_NEGRA.intValue());
             double valorNegrasConNegras = CFGGUI.this.procesarMejoresJugadas(JugadorBD.GO_FICHA_NEGRA.intValue());
             mapNegrasConNegras.put(new Punto(x, y), Double.valueOf(valorNegrasConNegras));
             double valorBlancasConNegras = CFGGUI.this.procesarMejoresJugadas(JugadorBD.GO_FICHA_BLANCA.intValue());
             mapBlancasConNegras.put(new Punto(x, y), Double.valueOf(valorBlancasConNegras));
             
             CFGGUI.this.siguienteTableroPanel.getCasilla(x, y).setJugador(JugadorBD.GO_FICHA_VACIA.intValue());
           }
         }
       }
       mapBlancasConBlancas = CFGGUI.sortByValue(mapBlancasConBlancas);
       mapNegrasConBlancas = CFGGUI.sortByValue(mapNegrasConBlancas);
       mapNegrasConNegras = CFGGUI.sortByValue(mapNegrasConNegras);
       mapBlancasConNegras = CFGGUI.sortByValue(mapBlancasConNegras);
       
       System.out.println("Blancas tirando blanca: " + mapBlancasConBlancas);
       System.out.println("Negras tirando blanca: " + mapNegrasConBlancas);
       int numJugadas = 3;
       int i = 0;
       if (valorActualBlancas < valorActualNegras) {
         for (Map.Entry<Punto, Double> entry : mapNegrasConBlancas.entrySet())
         {
           if (i >= mapNegrasConBlancas.size() - 3)
           {
             Punto p = (Punto)entry.getKey();
             CFGGUI.this.siguienteTableroPanel.getCasilla(p.getX(), p.getY()).setJugador(JugadorBD.GO_FICHA_BLANCA_SIGUIENTE.intValue());
           }
           i++;
         }
       } else {
         for (Map.Entry<Punto, Double> entry : mapBlancasConBlancas.entrySet())
         {
           if (i >= numJugadas) {
             break;
           }
           Punto p = (Punto)entry.getKey();
           CFGGUI.this.siguienteTableroPanel.getCasilla(p.getX(), p.getY()).setJugador(JugadorBD.GO_FICHA_BLANCA_SIGUIENTE.intValue());
           i++;
         }
       }
       CFGGUI.this.tableroPanel.repaint();
     }
   }
   
   static class ValueComparator implements Comparator<Map.Entry >{
       @Override
       public int compare(Map.Entry o1, Map.Entry o2)
       {
         return (((Comparable)o1.getValue()).compareTo(o2.getValue()));
       }
   }
   
   public static <K, V extends Comparable<? super V>> Map<K, V> sortByValue(Map<K, V> map)
   {
     List<Map.Entry<K, V>> list = new LinkedList(map.entrySet());
     ValueComparator comp = new ValueComparator();
     Collections.sort(list, comp);
     /* Collections.sort(list, new Comparator()
     {

       public int compare(Map.Entry<K, V> o1, Map.Entry<K, V> o2)
       {
         return ((Comparable)o1.getValue()).compareTo(o2.getValue());
       }
     });
     */
     Map<K, V> result = new LinkedHashMap();
     for (Map.Entry<K, V> entry : list) {
       result.put(entry.getKey(), entry.getValue());
     }
     return result;
   }
   
   public double procesarMejoresJugadas(int colorJugador)
   {
     int[][] tablero = new int[this.tamanioTablero][this.tamanioTablero];
     for (int x = 0; x < this.siguienteTableroPanel.getAncho().intValue(); x++) {
       for (int y = 0; y < this.siguienteTableroPanel.getAlto().intValue(); y++)
       {
         int jugador = (int)this.siguienteTableroPanel.getCasilla(y, x).getJugador();
         if (jugador == JugadorBD.GO_FICHA_BLANCA.intValue()) {
           tablero[x][y] = ProcesadorTablero.ETIQUETA_BLANCO;
         } else if (jugador == JugadorBD.GO_FICHA_NEGRA.intValue()) {
           tablero[x][y] = ProcesadorTablero.ETIQUETA_NEGRO;
         } else if (jugador == JugadorBD.GO_FICHA_VACIA.intValue()) {
           tablero[x][y] = ProcesadorTablero.ETIQUETA_ESPACIO;
         }
       }
     }
     ProcesadorTablero procesadorTablero = new ProcesadorTablero(tablero, this.tamanioTablero);
     
     procesadorTablero.leerGrafo();
     
 
     CFG cfg = CFG.generarCFG(procesadorTablero.getPiedrasCompuestas(), procesadorTablero.getLibertadesEspeciales());
     
 
     int tamanio = cfg.getNodos().size();
     
     double[][] matrizW = new double[tamanio][tamanio];
     double[] vectorX = new double[tamanio];
     double[] vectorH = new double[tamanio];
     for (int x = 0; x < tamanio; x++) {
       for (int y = 0; y < tamanio; y++)
       {
         double valor = 0.0D;
         if (x != y) {
           for (AristaCFG arista : ((NodoCFG)cfg.getNodos().get(x)).getAristas()) {
             if (arista.getDestino().getId() == y) {
               valor += arista.getPeso();
             }
           }
         }
         matrizW[x][y] = valor;
       }
     }
     for (int x = 0; x < tamanio; x++)
     {
       NodoCFG nodo = (NodoCFG)cfg.getNodos().get(x);
       double valor = nodo.getLibertades();
       vectorH[x] = valor;
     }
     for (int x = 0; x < tamanio; x++)
     {
       NodoCFG nodo = (NodoCFG)cfg.getNodos().get(x);
       double valor = (nodo.getTamanio() + Math.pow(CFG.VALOR_OJO, nodo.getOjos()) - 1.0D) * nodo.getColor();
       vectorX[x] = valor;
     }
     double valorNegras = 0.0D;
     double valorBlancas = 0.0D;
     for (int x = 0; x < tamanio; x++)
     {
       double valor = 0.0D;
       NodoCFG nodo = (NodoCFG)cfg.getNodos().get(x);
       for (int y = 0; y < tamanio; y++) {
         valor += -0.5D * (vectorX[x] * vectorX[y] * matrizW[x][y]);
       }
       valor -= vectorH[x] * Math.abs(vectorX[x]);
       if (nodo.getColor() == -1) {
         valorNegras += valor;
       } else {
         valorBlancas += valor;
       }
     }
     if (colorJugador == JugadorBD.GO_FICHA_BLANCA.intValue()) {
       return valorBlancas;
     }
     return valorNegras;
   }
   
   public boolean setSiguienteJugada()
   {
       boolean next = true;
     try
     {
       this.cargarSiguienteButton.setEnabled(true);
       this.cargarTodasButton.setEnabled(true);
       
       SGGoJugada jugada = (SGGoJugada)this.juego.getJugadas().get(this.indexJugada);
       if (jugada.getColor() == SGGoParser.NEGRO) {
         this.tableroPanel.getCasilla(jugada.getX(), jugada.getY()).setJugador(JugadorBD.GO_FICHA_NEGRA.intValue());
       } else {
         this.tableroPanel.getCasilla(jugada.getX(), jugada.getY()).setJugador(JugadorBD.GO_FICHA_BLANCA.intValue());
       }
       removerPiedrasCapturadas();
       this.tableroPanel.repaint();
       
       disparaAccionProcesar();
       guardarHistorico();
       actualizaGrafica();
       disparaAccionMejoresJugadas();
       this.indexJugada += 1;
     }
     catch (Exception e)
     {
       System.out.println("Termino");
       this.cargarSiguienteButton.setEnabled(false);
       this.cargarTodasButton.setEnabled(false);
       next = false;
     }
     System.out.println("Jugada " + this.indexJugada + " / " + this.juego.getJugadas().size());
     return next;
   }
   
   public void disparaAccionProcesar()
   {
     for (ActionListener a : this.procesarTableroButton.getActionListeners()) {
       a.actionPerformed(null);
     }
   }
   
   public void disparaAccionReiniciar()
   {
     for (ActionListener a : this.reiniciarTableroButton.getActionListeners()) {
       a.actionPerformed(null);
     }
   }
   
   public void disparaAccionMejoresJugadas()
   {
     for (ActionListener a : this.mejoresJugadasButton.getActionListeners()) {
       a.actionPerformed(null);
     }
   }
   
   public void guardarHistorico()
   {
     double valorBlancas = Double.parseDouble(this.totalBlancasField.getText());
     double valorNegras = Double.parseDouble(this.totalNegrasField.getText());
     
     this.historicoBlancas.add(Double.valueOf(valorBlancas));
     this.historicoNegras.add(Double.valueOf(valorNegras));
     if (valorNegras < valorBlancas) {
       this.historico.add(Integer.valueOf(GraficaPanel.VENTAJA_NEGRA));
     } else if (valorNegras > valorBlancas) {
       this.historico.add(Integer.valueOf(GraficaPanel.VENTAJA_BLANCA));
     } else {
       this.historico.add(Integer.valueOf(GraficaPanel.VENTAJA_EMPATE));
     }
   }
   
   public void actualizaGrafica()
   {
     this.graficaPanel.removeAll();
     this.graficaPanel.add(GraficaPanel.generarGrafica(this.tamanioTablero, this.tamanioTablero, this.historico), "wrap, alignx center");
     
     this.grafica2Panel.removeAll();
     this.grafica2Panel.add(GraficaEnergiaPanel.generarGrafica(this.tamanioTablero, this.tamanioTablero, this.historicoBlancas, this.historicoNegras), "wrap, alignx center");
   }
   
   public void guardarGraficas() throws IOException {
       ((ChartPanel)this.graficaPanel.getComponent(0)).doSaveAs();
   }
   
   public void reiniciarTodo()
   {
     this.indexJugada = 0;
     disparaAccionReiniciar();
     this.historico.clear();
     this.historicoBlancas.clear();
     this.historicoNegras.clear();
     this.graficaPanel.removeAll();
     this.grafica2Panel.removeAll();
   }
   
   public void habilitarMenuTablero()
   {
     this.tableroPanel.setEnabled(true);
     this.procesarTableroButton.setEnabled(true);
     this.mejoresJugadasButton.setEnabled(true);
     
     this.cargarSiguienteButton.setEnabled(false);
     this.cargarTodasButton.setEnabled(false);
     this.reiniciarPartidaButton.setEnabled(false);
     
     this.graficaPanel.removeAll();
     this.grafica2Panel.removeAll();
   }
   
   public void habilitarMenuPartida()
   {
     this.tableroPanel.setEnabled(false);
     this.procesarTableroButton.setEnabled(false);
     this.mejoresJugadasButton.setEnabled(false);
     
     this.cargarSiguienteButton.setEnabled(true);
     this.cargarTodasButton.setEnabled(true);
     this.reiniciarPartidaButton.setEnabled(true);
     
     this.graficaPanel.removeAll();
     this.grafica2Panel.removeAll();
   }
   
   public void removerPiedrasCapturadas()
   {
     int[][] tablero = new int[this.tamanioTablero][this.tamanioTablero];
     for (int x = 0; x < this.tableroPanel.getAncho().intValue(); x++) {
       for (int y = 0; y < this.tableroPanel.getAlto().intValue(); y++)
       {
         int jugador = (int)this.tableroPanel.getCasilla(y, x).getJugador();
         if (jugador == JugadorBD.GO_FICHA_BLANCA.intValue()) {
           tablero[x][y] = ProcesadorTablero.ETIQUETA_BLANCO;
         } else if (jugador == JugadorBD.GO_FICHA_NEGRA.intValue()) {
           tablero[x][y] = ProcesadorTablero.ETIQUETA_NEGRO;
         } else if (jugador == JugadorBD.GO_FICHA_VACIA.intValue()) {
           tablero[x][y] = ProcesadorTablero.ETIQUETA_ESPACIO;
         }
       }
     }
     ProcesadorTablero procesadorTablero = new ProcesadorTablero(tablero, this.tamanioTablero);
     
     procesadorTablero.leerGrafo();
     
 
     CFG cfg = CFG.generarCFG(procesadorTablero.getPiedrasCompuestas(), procesadorTablero.getLibertadesEspeciales());
     for (NodoCFG nodo : cfg.getNodos()) {
       if (nodo.getLibertades() == 0) {
         for (Punto punto : nodo.getUbicacionPiedras()) {
           this.tableroPanel.getCasilla(punto.getX(), punto.getY()).setJugador(JugadorBD.GO_FICHA_VACIA.intValue());
         }
       }
     }
   }
 }


