 package cs.cinvestav;
 
 import java.awt.Color;
 import java.awt.Font;
 import java.awt.FontMetrics;
 import java.awt.Graphics;
 import java.util.ArrayList;
 import java.util.Iterator;
 import javax.swing.JPanel;
 import net.miginfocom.swing.MigLayout;
 
 public class CFGPanel
   extends JPanel
 {
   private static final long serialVersionUID = -8677576844710654408L;
   public static int TAMANO_NODO = 26;
   public static int TAMANO_LIBERTAD_SIMPLE = 6;
   public static int TAMANO_LIBERTAD_ESPECIAL = 20;
   public static int TAMANO_NUMERO_PIEDRA = 10;
   public static int TAMANO_ESPACIO_NUMERO_PIEDRA = 3;
   private ArrayList<ArrayList<PiedraSimple>> piedrasCompuestas = new ArrayList();
   private ArrayList<LibertadEspecial> libertadesEspeciales = new ArrayList();
   private Integer ancho;
   private Integer alto;
   private AreaDibujo areaDibujo;
   
   public Integer getAncho()
   {
     return this.ancho;
   }
   
   public void setAncho(Integer ancho)
   {
     this.ancho = ancho;
   }
   
   public Integer getAlto()
   {
     return this.alto;
   }
   
   public void setAlto(Integer alto)
   {
     this.alto = alto;
   }
   
   public CFGPanel(Integer ancho, Integer alto)
   {
     this.ancho = ancho;
     this.alto = alto;
     
     setLayout(new MigLayout("gapx 0, gapy 0"));
     
     this.areaDibujo = new AreaDibujo();
     this.areaDibujo.setSize(Tablero.TAMANO_CASILLA.intValue() * ancho.intValue(), Tablero.TAMANO_CASILLA.intValue() * alto.intValue());
     
     add(this.areaDibujo, "cell 0 0, width " + Tablero.TAMANO_CASILLA.intValue() * ancho.intValue() + ", height " + Tablero.TAMANO_CASILLA.intValue() * alto.intValue());
   }
   
   public class AreaDibujo
     extends JPanel
   {
     private static final long serialVersionUID = -2447776245345409399L;
     
     public AreaDibujo() {}
     
     public void paint(Graphics g)
     {
       g.setColor(Color.WHITE);
       g.fillRect(0, 0, getWidth(), getHeight());
       
       FontMetrics fm = g.getFontMetrics();
 
       g.setColor(Color.BLACK);
       Iterator i$;
       PiedraSimple piedra;
       PiedraSimple primerPiedra;
       for (ArrayList<PiedraSimple> piedraCompuesta : CFGPanel.this.piedrasCompuestas)
       {
         primerPiedra = (PiedraSimple)piedraCompuesta.get(0);
         for (i$ = piedraCompuesta.iterator(); i$.hasNext();)
         {
           piedra = (PiedraSimple)i$.next();
           for (LibertadEspecial libertadEspecial : CFGPanel.this.libertadesEspeciales) {
             if (((piedra.getPosicionX() + 1 == libertadEspecial.getPosicionX()) && (piedra.getPosicionY() == libertadEspecial.getPosicionY())) || ((piedra.getPosicionX() - 1 == libertadEspecial.getPosicionX()) && (piedra.getPosicionY() == libertadEspecial.getPosicionY())) || ((piedra.getPosicionX() == libertadEspecial.getPosicionX()) && (piedra.getPosicionY() + 1 == libertadEspecial.getPosicionY())) || ((piedra.getPosicionX() == libertadEspecial.getPosicionX()) && (piedra.getPosicionY() - 1 == libertadEspecial.getPosicionY()))) {
                 g.drawLine(Tablero.TAMANO_CASILLA.intValue() * primerPiedra.getPosicionX() + Tablero.TAMANO_CASILLA.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() * primerPiedra.getPosicionY() + Tablero.TAMANO_CASILLA.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() * libertadEspecial.getPosicionX() + Tablero.TAMANO_CASILLA.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() * libertadEspecial.getPosicionY() + Tablero.TAMANO_CASILLA.intValue() / 2);
             }
           }
         }
       }
       
       //Iterator i$;
       
       PiedraSimple primerPiedra1;
       PiedraSimple piedra1;
       PiedraSimple primerPiedra2;
       g.setColor(Color.BLACK);
       for (ArrayList<PiedraSimple> piedraCompuesta1 : CFGPanel.this.piedrasCompuestas)
       {
         primerPiedra1 = (PiedraSimple)piedraCompuesta1.get(0);
         for (i$ = piedraCompuesta1.iterator(); i$.hasNext();)
         {
           piedra1 = (PiedraSimple)i$.next();
           for (ArrayList<PiedraSimple> piedraCompuesta2 : CFGPanel.this.piedrasCompuestas)
           {
             primerPiedra2 = (PiedraSimple)piedraCompuesta2.get(0);
             for (PiedraSimple piedra2 : piedraCompuesta2) {
               if (((piedra1.getPosicionX() + 1 == piedra2.getPosicionX()) && (piedra1.getPosicionY() == piedra2.getPosicionY())) || ((piedra1.getPosicionX() - 1 == piedra2.getPosicionX()) && (piedra1.getPosicionY() == piedra2.getPosicionY())) || ((piedra1.getPosicionX() == piedra2.getPosicionX()) && (piedra1.getPosicionY() + 1 == piedra2.getPosicionY())) || ((piedra1.getPosicionX() == piedra2.getPosicionX()) && (piedra1.getPosicionY() - 1 == piedra2.getPosicionY())))
               {
                 g.drawLine(Tablero.TAMANO_CASILLA.intValue() * primerPiedra1.getPosicionX() + Tablero.TAMANO_CASILLA.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() * primerPiedra1.getPosicionY() + Tablero.TAMANO_CASILLA.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() * primerPiedra2.getPosicionX() + Tablero.TAMANO_CASILLA.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() * primerPiedra2.getPosicionY() + Tablero.TAMANO_CASILLA.intValue() / 2);
                 break;
               }
             }
           }
         }
       }
       
       for (ArrayList<PiedraSimple> piedraCompuesta : CFGPanel.this.piedrasCompuestas)
       {
         PiedraSimple piedraS = (PiedraSimple)piedraCompuesta.get(0);
         int x = piedraS.getPosicionX() * Tablero.TAMANO_CASILLA.intValue() + (Tablero.TAMANO_CASILLA.intValue() / 2 - CFGPanel.TAMANO_NODO / 2);
         
         int y = piedraS.getPosicionY() * Tablero.TAMANO_CASILLA.intValue() + (Tablero.TAMANO_CASILLA.intValue() / 2 - CFGPanel.TAMANO_NODO / 2);
         
 
         String texto = piedraCompuesta.size() + "";
         
         int w = fm.stringWidth(texto);
         int h = fm.getAscent();
         if (piedraS.getColor() == ProcesadorTablero.ETIQUETA_NEGRO)
         {
           g.setColor(Color.BLACK);
           g.fillOval(x, y, CFGPanel.TAMANO_NODO, CFGPanel.TAMANO_NODO);
           g.setColor(Color.WHITE);
         }
         else
         {
           g.setColor(Color.WHITE);
           g.fillOval(x, y, CFGPanel.TAMANO_NODO, CFGPanel.TAMANO_NODO);
           g.setColor(Color.BLACK);
           g.drawOval(x, y, CFGPanel.TAMANO_NODO, CFGPanel.TAMANO_NODO);
         }
         g.drawString(texto, x + CFGPanel.TAMANO_NODO / 2 - w / 2, y + CFGPanel.TAMANO_NODO / 2 + h / 2);
       }
       for (LibertadEspecial libertadEspecial : CFGPanel.this.libertadesEspeciales)
       {
         int tamanio = CFGPanel.TAMANO_LIBERTAD_ESPECIAL;
         if (libertadEspecial.getColor() == ProcesadorTablero.ETIQUETA_ESPACIO) {
           tamanio = CFGPanel.TAMANO_LIBERTAD_SIMPLE;
         }
         int x = libertadEspecial.getPosicionX() * Tablero.TAMANO_CASILLA.intValue() + (Tablero.TAMANO_CASILLA.intValue() / 2 - tamanio / 2);
         
         int y = libertadEspecial.getPosicionY() * Tablero.TAMANO_CASILLA.intValue() + (Tablero.TAMANO_CASILLA.intValue() / 2 - tamanio / 2);
         
 
         String texto = libertadEspecial.getNombre();
         
         int w = fm.stringWidth(texto);
         int h = fm.getAscent();
         if (libertadEspecial.getColorDibujo() == Color.BLACK)
         {
           g.setColor(Color.BLACK);
           g.fillOval(x, y, tamanio, tamanio);
           g.setColor(Color.WHITE);
         }
         else
         {
           g.setColor(Color.WHITE);
           g.fillOval(x, y, tamanio, tamanio);
           g.setColor(Color.BLACK);
           g.drawOval(x, y, tamanio, tamanio);
         }
         g.drawString(texto, x + tamanio / 2 - w / 2, y + tamanio / 2 + h / 2);
       }
       int numeroPiedra = 1;
       g.setColor(Color.BLUE);
       g.setFont(new Font("TimesRoman", 0, CFGPanel.TAMANO_NUMERO_PIEDRA));
       for (ArrayList<PiedraSimple> piedraCompuesta : CFGPanel.this.piedrasCompuestas)
       {
         PiedraSimple piedraS = (PiedraSimple)piedraCompuesta.get(0);
         
         String texto = numeroPiedra + "";
         
         int x = piedraS.getPosicionX() * Tablero.TAMANO_CASILLA.intValue() + (Tablero.TAMANO_CASILLA.intValue() / 2 - CFGPanel.TAMANO_NODO / 2);
         
         int y = piedraS.getPosicionY() * Tablero.TAMANO_CASILLA.intValue() + (Tablero.TAMANO_CASILLA.intValue() / 2 - CFGPanel.TAMANO_NODO / 2);
         
 
         g.drawString(texto, x, y + CFGPanel.TAMANO_ESPACIO_NUMERO_PIEDRA);
         numeroPiedra++;
       }
     }
   }
   
   public ArrayList<ArrayList<PiedraSimple>> getPiedrasCompuestas()
   {
     return this.piedrasCompuestas;
   }
   
   public void setPiedrasCompuestas(ArrayList<ArrayList<PiedraSimple>> piedrasCompuestas)
   {
     this.piedrasCompuestas = piedrasCompuestas;
   }
   
   public ArrayList<LibertadEspecial> getLibertadesEspeciales()
   {
     return this.libertadesEspeciales;
   }
   
   public void setLibertadesEspeciales(ArrayList<LibertadEspecial> libertadesEspeciales)
   {
     this.libertadesEspeciales = libertadesEspeciales;
   }
 }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.CFGPanel

 * JD-Core Version:    0.7.0.1

 */