/*   1:    */ package cs.cinvestav;
/*   2:    */ 
/*   3:    */ import java.awt.Color;
/*   4:    */ import java.awt.Graphics;
/*   5:    */ import java.awt.Image;
/*   6:    */ import java.awt.event.MouseEvent;
/*   7:    */ import java.awt.event.MouseListener;
/*   8:    */ import java.io.PrintStream;
/*   9:    */ import java.util.HashMap;
/*  10:    */ import java.util.Random;
/*  11:    */ import java.util.Set;
/*  12:    */ import javax.swing.JPanel;
/*  13:    */ import javax.swing.SwingUtilities;
/*  14:    */ 
/*  15:    */ public class Casilla
/*  16:    */   extends JPanel
/*  17:    */   implements MouseListener
/*  18:    */ {
/*  19:    */   private Integer posicionX;
/*  20:    */   private Integer posicionY;
/*  21:    */   private Tablero tablero;
/*  22:    */   private double jugador;
/*  23:    */   private boolean enabled;
/*  24: 20 */   public static final Integer TAMANO_RECTANGULO = Integer.valueOf(2);
/*  25:    */   private static final long serialVersionUID = 4136138223890640425L;
/*  26:    */   
/*  27:    */   public Integer getPosicionX()
/*  28:    */   {
/*  29: 28 */     return this.posicionX;
/*  30:    */   }
/*  31:    */   
/*  32:    */   public void setPosicionX(Integer posicionX)
/*  33:    */   {
/*  34: 32 */     this.posicionX = posicionX;
/*  35:    */   }
/*  36:    */   
/*  37:    */   public Integer getPosicionY()
/*  38:    */   {
/*  39: 36 */     return this.posicionY;
/*  40:    */   }
/*  41:    */   
/*  42:    */   public void setPosicionY(Integer posicionY)
/*  43:    */   {
/*  44: 40 */     this.posicionY = posicionY;
/*  45:    */   }
/*  46:    */   
/*  47:    */   public Tablero gettablero()
/*  48:    */   {
/*  49: 44 */     return this.tablero;
/*  50:    */   }
/*  51:    */   
/*  52:    */   public void settablero(Tablero tablero)
/*  53:    */   {
/*  54: 48 */     this.tablero = tablero;
/*  55:    */   }
/*  56:    */   
/*  57:    */   public boolean getEnabled()
/*  58:    */   {
/*  59: 52 */     return this.enabled;
/*  60:    */   }
/*  61:    */   
/*  62:    */   public void setEnabled(boolean enabled)
/*  63:    */   {
/*  64: 57 */     this.enabled = enabled;
/*  65:    */   }
/*  66:    */   
/*  67:    */   public Casilla(Integer posicionX, Integer posicionY, Tablero tablero)
/*  68:    */   {
/*  69: 62 */     this.posicionX = posicionX;
/*  70: 63 */     this.posicionY = posicionY;
/*  71: 64 */     this.tablero = tablero;
/*  72: 65 */     this.jugador = 0.0D;
/*  73: 66 */     this.enabled = true;
/*  74:    */     
/*  75: 68 */     addMouseListener(this);
/*  76:    */   }
/*  77:    */   
/*  78:    */   public void paint(Graphics g)
/*  79:    */   {
/*  80: 73 */     if (this.tablero.getModoDibujo() == Tablero.JUEGO_GO)
/*  81:    */     {
/*  82: 74 */       g.setColor(new Color(238, 221, 130));
/*  83: 75 */       g.fillRect(0, 0, Tablero.TAMANO_CASILLA.intValue(), Tablero.TAMANO_CASILLA.intValue());
/*  84:    */       
/*  85: 77 */       g.setColor(Color.BLACK);
/*  86: 79 */       if (this.posicionY.intValue() != 0) {
/*  87: 80 */         g.fillRect(Tablero.TAMANO_CASILLA.intValue() / 2 - TAMANO_RECTANGULO.intValue() / 2, 0, TAMANO_RECTANGULO.intValue(), Tablero.TAMANO_CASILLA.intValue() / 2);
/*  88:    */       }
/*  89: 84 */       if (this.posicionY.intValue() != this.tablero.getAlto().intValue() - 1) {
/*  90: 85 */         g.fillRect(Tablero.TAMANO_CASILLA.intValue() / 2 - TAMANO_RECTANGULO.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() / 2, TAMANO_RECTANGULO.intValue(), Tablero.TAMANO_CASILLA.intValue() / 2);
/*  91:    */       }
/*  92: 90 */       if (this.posicionX.intValue() != 0) {
/*  93: 91 */         g.fillRect(0, Tablero.TAMANO_CASILLA.intValue() / 2 - TAMANO_RECTANGULO.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() / 2, TAMANO_RECTANGULO.intValue());
/*  94:    */       }
/*  95: 95 */       if (this.posicionX.intValue() != this.tablero.getAncho().intValue() - 1) {
/*  96: 96 */         g.fillRect(Tablero.TAMANO_CASILLA.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() / 2 - TAMANO_RECTANGULO.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() / 2, TAMANO_RECTANGULO.intValue());
/*  97:    */       }
/*  98:101 */       if (((this.posicionX.intValue() == 0) && (this.posicionY.intValue() == 0)) || ((this.posicionX.intValue() == this.tablero.getAncho().intValue() - 1) && (this.posicionY.intValue() == this.tablero.getAlto().intValue() - 1)) || ((this.posicionX.intValue() == 0) && (this.posicionY.intValue() == this.tablero.getAlto().intValue() - 1)) || ((this.posicionY.intValue() == 0) && (this.posicionX.intValue() == this.tablero.getAncho().intValue() - 1))) {
/*  99:106 */         g.fillRect(Tablero.TAMANO_CASILLA.intValue() / 2 - TAMANO_RECTANGULO.intValue() / 2, Tablero.TAMANO_CASILLA.intValue() / 2 - TAMANO_RECTANGULO.intValue() / 2, TAMANO_RECTANGULO.intValue(), TAMANO_RECTANGULO.intValue());
/* 100:    */       }
/* 101:    */     }
/* 102:    */     try
/* 103:    */     {
/* 104:114 */       if (this.jugador != 0.0D) {
/* 105:116 */         g.drawImage((Image)this.tablero.getJugadorBD().getJugadores().get(Integer.valueOf((int)this.jugador)), TAMANO_RECTANGULO.intValue() / 2, TAMANO_RECTANGULO.intValue() / 2, null);
/* 106:    */       }
/* 107:    */     }
/* 108:    */     catch (Exception e)
/* 109:    */     {
/* 110:123 */       System.out.println("Ex");
/* 111:    */     }
/* 112:    */   }
/* 113:    */   
/* 114:    */   public double generarJugadorAleatorio()
/* 115:    */   {
/* 116:128 */     double nuevoJugador = 0.0D;
/* 117:130 */     if (this.tablero.getModoDibujo() == Tablero.JUEGO_GO)
/* 118:    */     {
/* 119:131 */       int size = JugadorBD.JUGADORES_GO.size();
/* 120:132 */       int itemPosition = new Random().nextInt(size);
/* 121:    */       
/* 122:134 */       Integer item = (Integer)JugadorBD.JUGADORES_GO.toArray()[itemPosition];
/* 123:135 */       nuevoJugador = item.intValue();
/* 124:    */     }
/* 125:138 */     return nuevoJugador;
/* 126:    */   }
/* 127:    */   
/* 128:    */   public void mouseClicked(MouseEvent e)
/* 129:    */   {
/* 130:143 */     if (this.enabled)
/* 131:    */     {
/* 132:145 */       if (SwingUtilities.isRightMouseButton(e)) {
/* 133:146 */         this.jugador = JugadorBD.GO_FICHA_VACIA.intValue();
/* 134:148 */       } else if (this.jugador == JugadorBD.GO_FICHA_NEGRA.intValue()) {
/* 135:149 */         this.jugador = JugadorBD.GO_FICHA_BLANCA.intValue();
/* 136:    */       } else {
/* 137:151 */         this.jugador = JugadorBD.GO_FICHA_NEGRA.intValue();
/* 138:    */       }
/* 139:155 */       repaint();
/* 140:    */     }
/* 141:    */   }
/* 142:    */   
/* 143:    */   public void mouseEntered(MouseEvent e) {}
/* 144:    */   
/* 145:    */   public void mouseExited(MouseEvent e) {}
/* 146:    */   
/* 147:    */   public void mousePressed(MouseEvent e) {}
/* 148:    */   
/* 149:    */   public void mouseReleased(MouseEvent e) {}
/* 150:    */   
/* 151:    */   public double getJugador()
/* 152:    */   {
/* 153:184 */     return this.jugador;
/* 154:    */   }
/* 155:    */   
/* 156:    */   public void setJugador(double jugador)
/* 157:    */   {
/* 158:188 */     this.jugador = jugador;
/* 159:    */   }
/* 160:    */ }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.Casilla

 * JD-Core Version:    0.7.0.1

 */