 package cs.cinvestav;
 
 import java.io.PrintStream;
 import java.util.ArrayList;
 import java.util.HashSet;
 
 public class ProcesadorTablero
 {
   public static int ETIQUETA_NULO = -1;
   public static int ETIQUETA_ACTUAL = -2;
   public static int ETIQUETA_ESPACIO = 0;
   public static int ETIQUETA_BLANCO = 1;
   public static int ETIQUETA_NEGRO = 2;
   public static int ETIQUETA_OJO = 3;
   public static int ETIQUETA_ESCALERA_NEGRA = 4;
   public static int ETIQUETA_ESCALERA_BLANCA = 5;
   public static int ETIQUETA_RED_NEGRA = 6;
   public static int ETIQUETA_RED_BLANCA = 7;
   public static int ETIQUETA_INVASION_NEGRA = 8;
   public static int ETIQUETA_INVASION_BLANCA = 9;
   public static int ETIQUETA_REDUCCION_NEGRA = 10;
   public static int ETIQUETA_REDUCCION_BLANCA = 11;
   private int[][] tablero;
   private int tamanioTablero;
   private ArrayList<ArrayList<PiedraSimple>> piedrasCompuestas;
   private ArrayList<LibertadEspecial> libertadesEspeciales;
   
   public ProcesadorTablero(int[][] tablero, int tamanioTablero)
   {
     this.tablero = tablero;
     this.tamanioTablero = tamanioTablero;
   }
   
   public void leerGrafo()
   {
     this.piedrasCompuestas = new ArrayList();
     this.libertadesEspeciales = new ArrayList();
     try
     {
       etiquetaOjos();
       
 
 
 
       ArrayList<PiedraSimple> piedraCompuesta = null;
       while ((piedraCompuesta = getSiguientePiedraCompuesta()).size() != 0) {
         this.piedrasCompuestas.add(piedraCompuesta);
       }
       etiquetaRedesYEscaleras(this.piedrasCompuestas);
       for (int posicionY = 0; posicionY < this.tamanioTablero; posicionY++) {
         for (int posicionX = 0; posicionX < this.tamanioTablero; posicionX++)
         {
           int etiqueta = this.tablero[posicionY][posicionX];
           if ((etiqueta == ETIQUETA_OJO) || (etiqueta == ETIQUETA_ESCALERA_BLANCA) || (etiqueta == ETIQUETA_ESCALERA_NEGRA) || (etiqueta == ETIQUETA_RED_BLANCA) || (etiqueta == ETIQUETA_RED_NEGRA) || (etiqueta == ETIQUETA_INVASION_BLANCA) || (etiqueta == ETIQUETA_INVASION_NEGRA)) {
             this.libertadesEspeciales.add(new LibertadEspecial(posicionX, posicionY, etiqueta));
           }
         }
       }
       for (int posicionY = 0; posicionY < this.tamanioTablero; posicionY++)
       {
         int etiqueta;
         for (int posicionX = 0; posicionX < this.tamanioTablero; posicionX++)
         {
           etiqueta = this.tablero[posicionY][posicionX];
           if (etiqueta == ETIQUETA_ESPACIO) {
             for (ArrayList<PiedraSimple> piedraC : this.piedrasCompuestas) {
               for (PiedraSimple piedra : piedraC) {
                 if (((piedra.getPosicionX() + 1 == posicionX) && (piedra.getPosicionY() == posicionY)) || ((piedra.getPosicionX() - 1 == posicionX) && (piedra.getPosicionY() == posicionY)) || ((piedra.getPosicionX() == posicionX) && (piedra.getPosicionY() + 1 == posicionY)) || ((piedra.getPosicionX() == posicionX) && (piedra.getPosicionY() - 1 == posicionY)))
                 {
                   this.libertadesEspeciales.add(new LibertadEspecial(posicionX, posicionY, etiqueta));
 
                   break;
                 }
               }
             }
           }
         }
       }
     }
     catch (Exception e)
     {
       e.printStackTrace();
     }
   }
   
   private ArrayList<PiedraSimple> getSiguientePiedraCompuesta()
   {
     ArrayList<PiedraSimple> piedraCompuesta = new ArrayList();
     int etiqueta = ETIQUETA_NULO;
     for (int posicionY = 0; posicionY < this.tamanioTablero; posicionY++)
     {
       for (int posicionX = 0; posicionX < this.tamanioTablero; posicionX++) {
         if ((this.tablero[posicionY][posicionX] == ETIQUETA_NEGRO) || (this.tablero[posicionY][posicionX] == ETIQUETA_BLANCO))
         {
           etiqueta = this.tablero[posicionY][posicionX];
           this.tablero[posicionY][posicionX] = ETIQUETA_ACTUAL;
           break;
         }
       }
       if (etiqueta != ETIQUETA_NULO) {
         break;
       }
     }
     if (etiqueta != ETIQUETA_NULO)
     {
       int color;
       if (etiqueta == ETIQUETA_BLANCO) {
         color = ETIQUETA_BLANCO;
       } else {
         color = ETIQUETA_NEGRO;
       }
       while (!terminoLecturaPiedraCompuesta()) {
         for (int posicionY = 0; posicionY < this.tamanioTablero; posicionY++) {
           for (int posicionX = 0; posicionX < this.tamanioTablero; posicionX++) {
             if (this.tablero[posicionY][posicionX] == ETIQUETA_ACTUAL)
             {
               this.tablero[posicionY][posicionX] = ETIQUETA_NULO;
               piedraCompuesta.add(new PiedraSimple(posicionX, posicionY, color));
               try
               {
                 if (this.tablero[(posicionY + 1)][posicionX] == etiqueta) {
                   this.tablero[(posicionY + 1)][posicionX] = ETIQUETA_ACTUAL;
                 }
               }
               catch (Exception e) {}
               try
               {
                 if (this.tablero[(posicionY - 1)][posicionX] == etiqueta) {
                   this.tablero[(posicionY - 1)][posicionX] = ETIQUETA_ACTUAL;
                 }
               }
               catch (Exception e) {}
               try
               {
                 if (this.tablero[posicionY][(posicionX + 1)] == etiqueta) {
                   this.tablero[posicionY][(posicionX + 1)] = ETIQUETA_ACTUAL;
                 }
               }
               catch (Exception e) {}
               try
               {
                 if (this.tablero[posicionY][(posicionX - 1)] == etiqueta) {
                   this.tablero[posicionY][(posicionX - 1)] = ETIQUETA_ACTUAL;
                 }
               }
               catch (Exception e) {}
             }
           }
         }
       }
     }
     return piedraCompuesta;
   }
   
   private boolean terminoLecturaPiedraCompuesta()
   {
     for (int posicionY = 0; posicionY < this.tamanioTablero; posicionY++) {
       for (int posicionX = 0; posicionX < this.tamanioTablero; posicionX++) {
         if (this.tablero[posicionY][posicionX] == ETIQUETA_ACTUAL) {
           return false;
         }
       }
     }
     return true;
   }
   
   private void imprimePiedraCompuesta(ArrayList<PiedraSimple> piedraCompuesta)
   {
     for (int y = 0; y < this.tamanioTablero; y++)
     {
       for (int x = 0; x < this.tamanioTablero; x++)
       {
         int index = 0;
         for (PiedraSimple piedraSimple : piedraCompuesta)
         {
           if ((piedraSimple.getPosicionY() == y) && (piedraSimple.getPosicionX() == x))
           {
             if (piedraSimple.getColor() == ETIQUETA_BLANCO)
             {
               System.out.format("%2d", new Object[] { Integer.valueOf(ETIQUETA_BLANCO) }); break;
             }
             System.out.format("%2d", new Object[] { Integer.valueOf(ETIQUETA_NEGRO) });
             
             break;
           }
           index++;
         }
         if (index == piedraCompuesta.size()) {
           System.out.format("%2d", new Object[] { Integer.valueOf(ETIQUETA_ESPACIO) });
         }
       }
       System.out.println();
     }
   }
   
   private void imprimeTablero()
   {
     for (int posicionY = 0; posicionY < this.tamanioTablero; posicionY++)
     {
       for (int posicionX = 0; posicionX < this.tamanioTablero; posicionX++) {
         System.out.format("%2d", new Object[] { Integer.valueOf(this.tablero[posicionY][posicionX]) });
       }
       System.out.println();
     }
   }
   
   private void etiquetaOjos()
   {
     for (int posicionY = 0; posicionY < this.tamanioTablero; posicionY++) {
       for (int posicionX = 0; posicionX < this.tamanioTablero; posicionX++) {
         if (this.tablero[posicionY][posicionX] == ETIQUETA_ESPACIO)
         {
           int noBlanco = 0;
           int noNegro = 0;
           try
           {
             if (this.tablero[posicionY][(posicionX + 1)] == ETIQUETA_BLANCO) {
               noBlanco++;
             }
             if (this.tablero[posicionY][(posicionX + 1)] == ETIQUETA_NEGRO) {
               noNegro++;
             }
           }
           catch (Exception e)
           {
             noBlanco++;
             noNegro++;
           }
           try
           {
             if (this.tablero[posicionY][(posicionX - 1)] == ETIQUETA_BLANCO) {
               noBlanco++;
             }
             if (this.tablero[posicionY][(posicionX - 1)] == ETIQUETA_NEGRO) {
               noNegro++;
             }
           }
           catch (Exception e)
           {
             noBlanco++;
             noNegro++;
           }
           try
           {
             if (this.tablero[(posicionY + 1)][posicionX] == ETIQUETA_BLANCO) {
               noBlanco++;
             }
             if (this.tablero[(posicionY + 1)][posicionX] == ETIQUETA_NEGRO) {
               noNegro++;
             }
           }
           catch (Exception e)
           {
             noBlanco++;
             noNegro++;
           }
           try
           {
             if (this.tablero[(posicionY - 1)][posicionX] == ETIQUETA_BLANCO) {
               noBlanco++;
             }
             if (this.tablero[(posicionY - 1)][posicionX] == ETIQUETA_NEGRO) {
               noNegro++;
             }
           }
           catch (Exception e)
           {
             noBlanco++;
             noNegro++;
           }
           if ((noNegro == 4) || (noBlanco == 4)) {
             this.tablero[posicionY][posicionX] = ETIQUETA_OJO;
           }
         }
       }
     }
   }
   
   public void etiquetaRedesYEscaleras(ArrayList<ArrayList<PiedraSimple>> piedrasCompuestas)
   {
     for (ArrayList<PiedraSimple> piedraCompuesta : piedrasCompuestas)
     {
       HashSet<Punto> libertades = new HashSet();
       for (PiedraSimple piedraSimple : piedraCompuesta)
       {
         int etiqueta;
         try
         {
           etiqueta = this.tablero[(piedraSimple.getPosicionY() + 1)][piedraSimple.getPosicionX()];
           if ((etiqueta == ETIQUETA_ESPACIO) || (etiqueta == ETIQUETA_OJO) || (etiqueta == ETIQUETA_ESCALERA_BLANCA) || (etiqueta == ETIQUETA_ESCALERA_NEGRA) || (etiqueta == ETIQUETA_RED_BLANCA) || (etiqueta == ETIQUETA_RED_NEGRA) || (etiqueta == ETIQUETA_INVASION_BLANCA) || (etiqueta == ETIQUETA_INVASION_NEGRA)) {
             libertades.add(new Punto(piedraSimple.getPosicionX(), piedraSimple.getPosicionY() + 1));
           }
         }
         catch (Exception e) {}
         try
         {
           etiqueta = this.tablero[(piedraSimple.getPosicionY() - 1)][piedraSimple.getPosicionX()];
           if ((etiqueta == ETIQUETA_ESPACIO) || (etiqueta == ETIQUETA_OJO) || (etiqueta == ETIQUETA_ESCALERA_BLANCA) || (etiqueta == ETIQUETA_ESCALERA_NEGRA) || (etiqueta == ETIQUETA_RED_BLANCA) || (etiqueta == ETIQUETA_RED_NEGRA) || (etiqueta == ETIQUETA_INVASION_BLANCA) || (etiqueta == ETIQUETA_INVASION_NEGRA)) {
             libertades.add(new Punto(piedraSimple.getPosicionX(), piedraSimple.getPosicionY() - 1));
           }
         }
         catch (Exception e) {}
         try
         {
           etiqueta = this.tablero[piedraSimple.getPosicionY()][(piedraSimple.getPosicionX() + 1)];
           if ((etiqueta == ETIQUETA_ESPACIO) || (etiqueta == ETIQUETA_OJO) || (etiqueta == ETIQUETA_ESCALERA_BLANCA) || (etiqueta == ETIQUETA_ESCALERA_NEGRA) || (etiqueta == ETIQUETA_RED_BLANCA) || (etiqueta == ETIQUETA_RED_NEGRA) || (etiqueta == ETIQUETA_INVASION_BLANCA) || (etiqueta == ETIQUETA_INVASION_NEGRA)) {
             libertades.add(new Punto(piedraSimple.getPosicionX() + 1, piedraSimple.getPosicionY()));
           }
         }
         catch (Exception e) {}
         try
         {
           etiqueta = this.tablero[piedraSimple.getPosicionY()][(piedraSimple.getPosicionX() - 1)];
           if ((etiqueta == ETIQUETA_ESPACIO) || (etiqueta == ETIQUETA_OJO) || (etiqueta == ETIQUETA_ESCALERA_BLANCA) || (etiqueta == ETIQUETA_ESCALERA_NEGRA) || (etiqueta == ETIQUETA_RED_BLANCA) || (etiqueta == ETIQUETA_RED_NEGRA) || (etiqueta == ETIQUETA_INVASION_BLANCA) || (etiqueta == ETIQUETA_INVASION_NEGRA)) {
             libertades.add(new Punto(piedraSimple.getPosicionX() - 1, piedraSimple.getPosicionY()));
           }
         }
         catch (Exception e) {}
       }
       ArrayList<Punto> libs = new ArrayList(libertades);
       if (libertades.size() == 1) {
         if (((PiedraSimple)piedraCompuesta.get(0)).getColor() == ETIQUETA_BLANCO)
         {
           if (this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] != ETIQUETA_OJO) {
             this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] = ETIQUETA_ESCALERA_NEGRA;
           }
         }
         else if (this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] != ETIQUETA_OJO) {
           this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] = ETIQUETA_ESCALERA_BLANCA;
         }
       }
       if (libertades.size() == 2) {
         if (((PiedraSimple)piedraCompuesta.get(0)).getColor() == ETIQUETA_BLANCO)
         {
           if (this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] != ETIQUETA_OJO) {
             this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] = ETIQUETA_RED_NEGRA;
           }
           if (this.tablero[((Punto)libs.get(1)).getY()][((Punto)libs.get(1)).getX()] != ETIQUETA_OJO) {
             this.tablero[((Punto)libs.get(1)).getY()][((Punto)libs.get(1)).getX()] = ETIQUETA_RED_NEGRA;
           }
         }
         else
         {
           if (this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] != ETIQUETA_OJO) {
             this.tablero[((Punto)libs.get(0)).getY()][((Punto)libs.get(0)).getX()] = ETIQUETA_RED_BLANCA;
           }
           if (this.tablero[((Punto)libs.get(1)).getY()][((Punto)libs.get(1)).getX()] != ETIQUETA_OJO) {
             this.tablero[((Punto)libs.get(1)).getY()][((Punto)libs.get(1)).getX()] = ETIQUETA_RED_BLANCA;
           }
         }
       }
     }
   }
   
   public ArrayList<ArrayList<PiedraSimple>> getPiedrasCompuestas()
   {
     return this.piedrasCompuestas;
   }
   
   public ArrayList<LibertadEspecial> getLibertadesEspeciales()
   {
     return this.libertadesEspeciales;
   }
 }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.ProcesadorTablero

 * JD-Core Version:    0.7.0.1

 */