/*   1:    */ package cs.cinvestav;
/*   2:    */ 
/*   3:    */ import java.io.BufferedReader;
/*   4:    */ import java.io.FileReader;
/*   5:    */ import java.util.ArrayList;
/*   6:    */ import java.util.regex.Matcher;
/*   7:    */ import java.util.regex.Pattern;
/*   8:    */ 
/*   9:    */ public class SGGoParser
/*  10:    */ {
/*  11: 20 */   public static int NEGRO = 0;
/*  12: 21 */   public static int BLANCO = 1;
/*  13:    */   
/*  14:    */   public static SGGoJuego getJuegoGo(String file)
/*  15:    */   {
/*  16:    */     try
/*  17:    */     {
/*  18: 25 */       BufferedReader br = new BufferedReader(new FileReader(file));
/*  19:    */       
/*  20: 27 */       String contenido = "";
/*  21: 28 */       String linea = "";
/*  22: 29 */       while ((linea = br.readLine()) != null) {
/*  23: 30 */         contenido = contenido + linea;
/*  24:    */       }
/*  25: 32 */       br.close();
/*  26:    */       
/*  27: 34 */       Pattern pattern = Pattern.compile("(.*?)\\[(.*?)\\]");
/*  28: 35 */       Matcher matcher = pattern.matcher(contenido);
/*  29:    */       
/*  30: 37 */       int tamanio = 0;
/*  31: 38 */       String nombreEvento = "";
/*  32: 39 */       String jugadorNegro = "";
/*  33: 40 */       String jugadorBlanco = "";
/*  34: 41 */       String fecha = "";
/*  35: 42 */       String lugar = "";
/*  36: 43 */       int ganador = -1;
/*  37:    */       
/*  38: 45 */       ArrayList<SGGoJugada> jugadas = new ArrayList();
/*  39: 47 */       while (matcher.find())
/*  40:    */       {
/*  41: 48 */         String clave = matcher.group(1);
/*  42: 49 */         String valor = matcher.group(2);
/*  43:    */         
/*  44: 51 */         clave = clave.replace(";", "");
/*  45: 52 */         clave = clave.replace("(", "");
/*  46: 53 */         clave = clave.replace(" ", "");
/*  47:    */         int x;
/*  48:    */         int y;
/*  49: 55 */         switch (clave)
/*  50:    */         {
/*  51:    */         case "SZ": 
/*  52: 57 */           tamanio = Integer.parseInt(valor);
/*  53: 58 */           break;
/*  54:    */         case "EV": 
/*  55: 60 */           nombreEvento = valor;
/*  56: 61 */           break;
/*  57:    */         case "PB": 
/*  58: 63 */           jugadorNegro = valor;
/*  59: 64 */           break;
/*  60:    */         case "PW": 
/*  61: 66 */           jugadorBlanco = valor;
/*  62:    */         case "DT": 
/*  63: 68 */           fecha = valor;
/*  64:    */         case "PC": 
/*  65: 70 */           lugar = valor;
/*  66:    */         case "RE": 
/*  67:    */           try
/*  68:    */           {
/*  69: 73 */             if (valor.charAt(0) == 'W') {
/*  70: 74 */               ganador = BLANCO;
/*  71:    */             } else {
/*  72: 76 */               ganador = NEGRO;
/*  73:    */             }
/*  74:    */           }
/*  75:    */           catch (Exception e)
/*  76:    */           {
/*  77: 79 */             ganador = -1;
/*  78:    */           }
/*  79:    */         case "B": 
/*  80:    */           try
/*  81:    */           {
/*  82: 84 */             x = valor.charAt(0) - 'a';
/*  83: 85 */             y = valor.charAt(1) - 'a';
/*  84:    */           }
/*  85:    */           catch (Exception e)
/*  86:    */           {
/*  87: 87 */             x = -1;
/*  88: 88 */             y = -1;
/*  89:    */           }
/*  90: 90 */           jugadas.add(new SGGoJugada(x, y, NEGRO));
/*  91: 91 */           break;
/*  92:    */         case "W": 
/*  93:    */           try
/*  94:    */           {
/*  95: 94 */             x = valor.charAt(0) - 'a';
/*  96: 95 */             y = valor.charAt(1) - 'a';
/*  97:    */           }
/*  98:    */           catch (Exception e)
/*  99:    */           {
/* 100: 97 */             x = -1;
/* 101: 98 */             y = -1;
/* 102:    */           }
/* 103:100 */           jugadas.add(new SGGoJugada(x, y, BLANCO));
/* 104:    */         }
/* 105:    */       }
/* 106:105 */       return new SGGoJuego(tamanio, nombreEvento, jugadorNegro, jugadorBlanco, fecha, lugar, ganador, jugadas);
/* 107:    */     }
/* 108:    */     catch (Exception e)
/* 109:    */     {
/* 110:107 */       e.printStackTrace();
/* 111:    */     }
/* 112:108 */     return null;
/* 113:    */   }
/* 114:    */ }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.SGGoParser

 * JD-Core Version:    0.7.0.1

 */