/*  1:   */ package cs.cinvestav;
/*  2:   */ 
/*  3:   */ import java.awt.Dimension;
/*  4:   */ import java.util.ArrayList;
/*  5:   */ import javax.swing.BorderFactory;
/*  6:   */ import org.jfree.chart.ChartFactory;
/*  7:   */ import org.jfree.chart.ChartPanel;
/*  8:   */ import org.jfree.chart.JFreeChart;
/*  9:   */ import org.jfree.chart.plot.PlotOrientation;
/* 10:   */ import org.jfree.chart.plot.XYPlot;
/* 11:   */ import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
/* 12:   */ import org.jfree.data.xy.XYDataset;
/* 13:   */ import org.jfree.data.xy.XYSeries;
/* 14:   */ import org.jfree.data.xy.XYSeriesCollection;
/* 15:   */ 
/* 16:   */ public class GraficaEnergiaPanel
/* 17:   */ {
/* 18:17 */   public static int VENTAJA_BLANCA = 1;
/* 19:18 */   public static int VENTAJA_EMPATE = 0;
/* 20:19 */   public static int VENTAJA_NEGRA = -1;
/* 21:   */   
/* 22:   */   public static XYDataset createDataset(int ancho, int alto, ArrayList<Double> historicoBlancas, ArrayList<Double> historicoNegras)
/* 23:   */   {
/* 24:22 */     XYSeries serieBlancas = new XYSeries("Blancas");
/* 25:23 */     XYSeries serieNegras = new XYSeries("Negras");
/* 26:   */     
/* 27:25 */     double cuentaBlancas = 0.0D;
/* 28:26 */     double cuentaNegras = 0.0D;
/* 29:32 */     for (int i = 0; i < historicoBlancas.size(); i++)
/* 30:   */     {
/* 31:43 */       serieBlancas.add(i + 1, (Number)historicoBlancas.get(i));
/* 32:44 */       serieNegras.add(i + 1, (Number)historicoNegras.get(i));
/* 33:   */     }
/* 34:49 */     XYSeriesCollection dataset = new XYSeriesCollection();
/* 35:50 */     dataset.addSeries(serieBlancas);
/* 36:51 */     dataset.addSeries(serieNegras);
/* 37:   */     
/* 38:53 */     return dataset;
/* 39:   */   }
/* 40:   */   
/* 41:   */   public static ChartPanel generarGrafica(int ancho, int alto, ArrayList<Double> historicoBlancas, ArrayList<Double> historicoNegras)
/* 42:   */   {
/* 43:58 */     XYDataset dataset = createDataset(ancho, alto, historicoBlancas, historicoNegras);
/* 44:   */     
/* 45:60 */     JFreeChart chart = ChartFactory.createXYLineChart("", "Jugadas", "Ventaja", dataset, PlotOrientation.VERTICAL, true, false, false);
/* 46:   */     
/* 47:   */ 
/* 48:   */ 
/* 49:   */ 
/* 50:   */ 
/* 51:   */ 
/* 52:   */ 
/* 53:   */ 
/* 54:   */ 
/* 55:   */ 
/* 56:71 */     XYPlot plot = (XYPlot)chart.getPlot();
/* 57:72 */     XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
/* 58:73 */     renderer.setSeriesLinesVisible(0, true);
/* 59:74 */     renderer.setSeriesShapesVisible(0, true);
/* 60:75 */     renderer.setSeriesLinesVisible(1, true);
/* 61:76 */     renderer.setSeriesShapesVisible(1, true);
/* 62:77 */     plot.setRenderer(renderer);
/* 63:   */     
/* 64:79 */     ChartPanel chartPanel = new ChartPanel(chart);
/* 65:80 */     chartPanel.setPreferredSize(new Dimension((int)(Tablero.TAMANO_CASILLA.intValue() * ancho * 1.5D), Tablero.TAMANO_CASILLA.intValue() * alto));
/* 66:81 */     chartPanel.setBorder(BorderFactory.createTitledBorder("Energía del juego"));
/* 67:82 */     return chartPanel;
/* 68:   */   }
/* 69:   */ }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.GraficaEnergiaPanel

 * JD-Core Version:    0.7.0.1

 */