/*  1:   */ package cs.cinvestav;
/*  2:   */ 
/*  3:   */ import java.awt.Dimension;
/*  4:   */ import java.util.ArrayList;
/*  5:   */ import javax.swing.BorderFactory;
/*  6:   */ import org.jfree.chart.ChartFactory;
/*  7:   */ import org.jfree.chart.ChartPanel;
/*  8:   */ import org.jfree.chart.JFreeChart;
/*  9:   */ import org.jfree.chart.plot.PlotOrientation;
/* 10:   */ import org.jfree.data.category.CategoryDataset;
/* 11:   */ import org.jfree.data.general.DefaultKeyedValues2DDataset;
/* 12:   */ import org.jfree.data.general.KeyedValues2DDataset;
/* 13:   */ 
/* 14:   */ public class GraficaPanel
/* 15:   */ {
/* 16:15 */   public static int VENTAJA_BLANCA = 1;
/* 17:16 */   public static int VENTAJA_EMPATE = 0;
/* 18:17 */   public static int VENTAJA_NEGRA = -1;
/* 19:   */   
/* 20:   */   public static KeyedValues2DDataset createDataset(int ancho, int alto, ArrayList<Integer> historico)
/* 21:   */   {
/* 22:20 */     DefaultKeyedValues2DDataset data = new DefaultKeyedValues2DDataset();
/* 23:   */     
/* 24:22 */     double cuentaBlancas = 0.0D;
/* 25:23 */     double cuentaNegras = 0.0D;
/* 26:   */     
/* 27:25 */     int mod = 1;
/* 28:26 */     if (historico.size() > ancho * alto / 3) {
/* 29:27 */       mod = 3;
/* 30:   */     }
/* 31:30 */     for (int i = 0; i < historico.size(); i++)
/* 32:   */     {
/* 33:31 */       if (((Integer)historico.get(i)).intValue() == VENTAJA_BLANCA) {
/* 34:32 */         cuentaBlancas += 1.0D;
/* 35:   */       }
/* 36:34 */       if (((Integer)historico.get(i)).intValue() == VENTAJA_NEGRA) {
/* 37:35 */         cuentaNegras += 1.0D;
/* 38:   */       }
/* 39:38 */       if (i % mod == 0)
/* 40:   */       {
/* 41:41 */         data.addValue(cuentaBlancas, "Blanco", i + 1 + "");
/* 42:42 */         data.addValue(-cuentaNegras, "Negro", i + 1 + "");
/* 43:43 */         cuentaBlancas = 0.0D;
/* 44:44 */         cuentaNegras = 0.0D;
/* 45:   */       }
/* 46:   */     }
/* 47:47 */     return data;
/* 48:   */   }
/* 49:   */   
/* 50:   */   public static ChartPanel generarGrafica(int ancho, int alto, ArrayList<Integer> historico)
/* 51:   */   {
/* 52:52 */     CategoryDataset dataset = createDataset(ancho, alto, historico);
/* 53:   */     
/* 54:54 */     JFreeChart chart = ChartFactory.createStackedBarChart("", "Jugadas", "Ventaja", dataset, PlotOrientation.HORIZONTAL, true, true, false);
/* 55:   */     
/* 56:   */ 
/* 57:   */ 
/* 58:   */ 
/* 59:   */ 
/* 60:   */ 
/* 61:   */ 
/* 62:   */ 
/* 63:   */ 
/* 64:   */ 
/* 65:65 */     ChartPanel chartPanel = new ChartPanel(chart);
/* 66:66 */     chartPanel.setPreferredSize(new Dimension(Tablero.TAMANO_CASILLA.intValue() * ancho, Tablero.TAMANO_CASILLA.intValue() * alto));
/* 67:67 */     chartPanel.setBorder(BorderFactory.createTitledBorder("Desarrollo del juego"));
/* 68:68 */     return chartPanel;
/* 69:   */   }
/* 70:   */ }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.GraficaPanel

 * JD-Core Version:    0.7.0.1

 */