/*  1:   */ package cs.cinvestav;
/*  2:   */ 
/*  3:   */ import java.awt.GridLayout;
/*  4:   */ import java.util.ArrayList;
/*  5:   */ import javax.swing.JPanel;
/*  6:   */ import javax.swing.JScrollPane;
/*  7:   */ import javax.swing.JTextField;
/*  8:   */ import net.miginfocom.swing.MigLayout;
/*  9:   */ 
/* 10:   */ public class IsingPanel
/* 11:   */   extends JPanel
/* 12:   */ {
/* 13:   */   private static final long serialVersionUID = 6036291490853824212L;
/* 14:   */   private JScrollPane scroll;
/* 15:   */   private InnerPanel innerPanel;
/* 16:   */   private int alto;
/* 17:   */   private int ancho;
/* 18:   */   
/* 19:   */   public InnerPanel getInnerPanel()
/* 20:   */   {
/* 21:17 */     return this.innerPanel;
/* 22:   */   }
/* 23:   */   
/* 24:   */   public void setInnerPanel(InnerPanel innerPanel)
/* 25:   */   {
/* 26:21 */     this.innerPanel = innerPanel;
/* 27:   */   }
/* 28:   */   
/* 29:   */   public IsingPanel(Integer ancho, Integer alto)
/* 30:   */   {
/* 31:28 */     this.ancho = ancho.intValue();
/* 32:29 */     this.alto = alto.intValue();
/* 33:   */     
/* 34:31 */     setLayout(new MigLayout("gapx 0, gapy 0, fill"));
/* 35:   */     
/* 36:33 */     this.innerPanel = new InnerPanel();
/* 37:   */     
/* 38:35 */     this.scroll = new JScrollPane(this.innerPanel);
/* 39:36 */     this.scroll.setSize(Tablero.TAMANO_CASILLA.intValue() * ancho.intValue(), Tablero.TAMANO_CASILLA.intValue() * alto.intValue());
/* 40:   */     
/* 41:   */ 
/* 42:39 */     add(this.scroll, "cell 0 0, width " + Tablero.TAMANO_CASILLA.intValue() * ancho.intValue() + ", height " + Tablero.TAMANO_CASILLA.intValue() * alto.intValue() + ", grow");
/* 43:   */   }
/* 44:   */   
/* 45:   */   public void actualizar(CFG cfg)
/* 46:   */   {
/* 47:44 */     this.innerPanel.actualizar(cfg);
/* 48:   */   }
/* 49:   */   
/* 50:   */   public double getValor(int x, int y)
/* 51:   */   {
/* 52:48 */     return this.innerPanel.getValor(x, y);
/* 53:   */   }
/* 54:   */   
/* 55:   */   public class InnerPanel
/* 56:   */     extends JPanel
/* 57:   */   {
/* 58:   */     private JTextField[][] fields;
/* 59:   */     
/* 60:   */     public InnerPanel() {}
/* 61:   */     
/* 62:   */     public void actualizar(CFG cfg)
/* 63:   */     {
/* 64:56 */       removeAll();
/* 65:   */       
/* 66:58 */       int tamanio = cfg.getNodos().size();
/* 67:59 */       setLayout(new GridLayout(tamanio, tamanio));
/* 68:   */       
/* 69:61 */       this.fields = new JTextField[tamanio][tamanio];
/* 70:63 */       for (int x = 0; x < tamanio; x++) {
/* 71:64 */         for (int y = 0; y < tamanio; y++)
/* 72:   */         {
/* 73:66 */           double valor = 0.0D;
/* 74:67 */           if (x != y) {
/* 75:68 */             for (AristaCFG arista : ((NodoCFG)cfg.getNodos().get(x)).getAristas()) {
/* 76:69 */               if (arista.getDestino().getId() == y) {
/* 77:70 */                 valor += arista.getPeso();
/* 78:   */               }
/* 79:   */             }
/* 80:   */           }
/* 81:75 */           this.fields[x][y] = new JTextField(valor + "");
/* 82:76 */           this.fields[x][y].setEditable(false);
/* 83:77 */           this.fields[x][y].setToolTipText("W [ " + (x + 1) + " , " + (y + 1) + " ]");
/* 84:78 */           this.fields[x][y].setHorizontalAlignment(0);
/* 85:   */           
/* 86:80 */           add(this.fields[x][y]);
/* 87:   */         }
/* 88:   */       }
/* 89:   */     }
/* 90:   */     
/* 91:   */     public double getValor(int x, int y)
/* 92:   */     {
/* 93:86 */       return Double.parseDouble(this.fields[x][y].getText());
/* 94:   */     }
/* 95:   */   }
/* 96:   */ }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.IsingPanel

 * JD-Core Version:    0.7.0.1

 */