/*  1:   */ package cs.cinvestav;
/*  2:   */ 
/*  3:   */ import java.awt.GridLayout;
/*  4:   */ import java.util.ArrayList;
/*  5:   */ import javax.swing.JPanel;
/*  6:   */ import javax.swing.JScrollPane;
/*  7:   */ import javax.swing.JTextField;
/*  8:   */ import net.miginfocom.swing.MigLayout;
/*  9:   */ 
/* 10:   */ public class VectorLibPanel
/* 11:   */   extends JPanel
/* 12:   */ {
/* 13:   */   private static final long serialVersionUID = 6037291490853824212L;
/* 14:   */   private JScrollPane scroll;
/* 15:   */   private InnerPanel innerPanel;
/* 16:16 */   public static int SCROLL_SIZE = 10;
/* 17:   */   private int ancho;
/* 18:   */   
/* 19:   */   public VectorLibPanel(Integer ancho)
/* 20:   */   {
/* 21:20 */     this.ancho = ancho.intValue();
/* 22:   */     
/* 23:22 */     setLayout(new MigLayout("gapx 0, gapy 0, fill"));
/* 24:   */     
/* 25:24 */     this.innerPanel = new InnerPanel();
/* 26:   */     
/* 27:26 */     this.scroll = new JScrollPane(this.innerPanel);
/* 28:27 */     this.scroll.setSize(Tablero.TAMANO_CASILLA.intValue() + SCROLL_SIZE, Tablero.TAMANO_CASILLA.intValue() * ancho.intValue());
/* 29:   */     
/* 30:   */ 
/* 31:30 */     add(this.scroll, "cell 0 0, width " + (Tablero.TAMANO_CASILLA.intValue() + SCROLL_SIZE) + ", height " + Tablero.TAMANO_CASILLA.intValue() * ancho.intValue() + ", grow");
/* 32:   */   }
/* 33:   */   
/* 34:   */   public InnerPanel getInnerPanel()
/* 35:   */   {
/* 36:35 */     return this.innerPanel;
/* 37:   */   }
/* 38:   */   
/* 39:   */   public void setInnerPanel(InnerPanel innerPanel)
/* 40:   */   {
/* 41:39 */     this.innerPanel = innerPanel;
/* 42:   */   }
/* 43:   */   
/* 44:   */   public void actualizar(CFG cfg)
/* 45:   */   {
/* 46:44 */     this.innerPanel.actualizar(cfg);
/* 47:   */   }
/* 48:   */   
/* 49:   */   public double getValor(int x)
/* 50:   */   {
/* 51:48 */     return this.innerPanel.getValor(x);
/* 52:   */   }
/* 53:   */   
/* 54:   */   public class InnerPanel
/* 55:   */     extends JPanel
/* 56:   */   {
/* 57:   */     private JTextField[] fields;
/* 58:   */     
/* 59:   */     public InnerPanel() {}
/* 60:   */     
/* 61:   */     public void actualizar(CFG cfg)
/* 62:   */     {
/* 63:56 */       removeAll();
/* 64:57 */       int tamanio = cfg.getNodos().size();
/* 65:58 */       setLayout(new GridLayout(tamanio, 1));
/* 66:   */       
/* 67:60 */       this.fields = new JTextField[tamanio];
/* 68:62 */       for (int x = 0; x < tamanio; x++)
/* 69:   */       {
/* 70:63 */         NodoCFG nodo = (NodoCFG)cfg.getNodos().get(x);
/* 71:64 */         double valor = nodo.getLibertades();
/* 72:   */         
/* 73:66 */         this.fields[x] = new JTextField(valor + "");
/* 74:67 */         this.fields[x].setEditable(false);
/* 75:68 */         this.fields[x].setToolTipText("H [ " + (x + 1) + " ]");
/* 76:69 */         this.fields[x].setHorizontalAlignment(0);
/* 77:   */         
/* 78:71 */         add(this.fields[x]);
/* 79:   */       }
/* 80:   */     }
/* 81:   */     
/* 82:   */     public double getValor(int x)
/* 83:   */     {
/* 84:76 */       return Double.parseDouble(this.fields[x].getText());
/* 85:   */     }
/* 86:   */   }
/* 87:   */ }



/* Location:           C:\Users\Arturo\Documents\ProyectoIsing\ProyectoIsing\GoIsingAPI - copia\lib\GoIsingLibrary\

 * Qualified Name:     cs.cinvestav.VectorLibPanel

 * JD-Core Version:    0.7.0.1

 */